<?php
	$img_loader_url = plugins_url('includes/images/loader.gif',dirname(__FILE__));
	global $mowafutility,$mowaf_dirname;
	if(current_user_can( 'manage_options' )  && isset($_POST['option']) )
	{
		$option = sanitize_text_field($_POST['option']);
		switch($option)
		{
			case "mowaf_block_ip_range":
				mowaf_handle_range_blocking();		break;
			case "mowaf_browser_blocking":
				mowaf_handle_browser_blocking();		break;
			case "mowaf_enable_htaccess_blocking":
				mowaf_handle_htaccess_blocking();		break;
			case "mowaf_enable_user_agent_blocking":
				mowaf_handle_user_agent_blocking();	break;
			case "mowaf_block_countries":
				mowaf_handle_country_block();			break;
			case "mowaf_block_referrer":
				mowaf_handle_block_referrer();		break;
			
		}
	}

	$range_count 	= is_numeric(get_site_option('mo_wpns_iprange_count'))
					&& intval(get_site_option('mo_wpns_iprange_count')) !=0  ? intval(get_site_option('mo_wpns_iprange_count')) : 1;
	$htaccess_block = get_site_option('mo_wpns_enable_htaccess_blocking')   	? "checked" : "";
	$user_agent 	= get_site_option('mo_wpns_enable_user_agent_blocking') 	? "checked" : "";
	$block_chrome 	= get_site_option('mo_wpns_block_chrome') 			   	? "checked" : "";
	$block_ie 		= get_site_option('mo_wpns_block_ie')			   	   	? "checked" : "";
	$block_firefox 	= get_site_option('mo_wpns_block_firefox') 			   	? "checked" : "";
	$block_safari	= get_site_option('mo_wpns_block_safari') 			   	? "checked" : "";
	$block_opera	= get_site_option('mo_wpns_block_opera') 			   	? "checked" : "";
	$block_edge		= get_site_option('mo_wpns_block_edge') 			   	   	? "checked" : "";
	$country		= MOWAF_Constants::$country;
	$codes			= get_site_option( "mo_wpns_countrycodes");
	$referrers 		= get_site_option( 'mo_wpns_referrers');
	$referrers 		= explode(";",$referrers);
	$current_browser= $mowafutility->getCurrentBrowser();
	$start = array();
	$end   = array();
	for($i = 1 ; $i <= $range_count ; $i++){
		$ip_range = get_site_option("mo_wpns_iprange_range_".$i);
		if($ip_range){
			$a = explode('-', $ip_range);
			$start[$i] = $a[0];
			$end[$i]   = $a[1]; 
		}

	}
	if(!isset($start[1])){
		$start[1] = '';
	}
	if(!isset($end[1])){
		$end[1] = '';
	}
			
	switch($current_browser)
	{
		case "chrome":
			$block_chrome = 'disabled';		break;
		case "ie":
			$block_ie 	  = 'disabled';		break;
		case "firefox":
			$block_firefox= 'disabled';		break;
		case "safari":
			$block_safari = 'disabled';		break;
		case "edge":
			$block_edge	  = 'disabled';		break;
		case "opera":
			$block_opera  = 'disabled';		break;	
	}

	include $mowaf_dirname . 'views'.DIRECTORY_SEPARATOR.'advanced-blocking.php';

	function mowaf_handle_range_blocking()
	{
		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-advance-blocking-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		$flag=0;
		$max_allowed_ranges = 100;
		$added_mappings_ranges  = 0 ;
		for($i=1;$i<=$max_allowed_ranges;$i++){
			if(isset($_POST['start_'.$i]) && isset($_POST['end_'.$i]) && !empty($_POST['start_'.$i]) && !empty($_POST['end_'.$i])){

				$_POST['start_'.$i] = sanitize_text_field($_POST['start_'.$i]);
				$_POST['end_'.$i]   = sanitize_text_field($_POST['end_'.$i]);

				if(filter_var($_POST['start_'.$i] , FILTER_VALIDATE_IP )  &&  filter_var($_POST['end_'.$i] , FILTER_VALIDATE_IP ) && (ip2long($_POST['end_'.$i]) > ip2long($_POST['start_'.$i])) ){
					$range = '';
					$range = 	sanitize_text_field($_POST['start_'.$i]);
					$range .= '-';
					$range .=  sanitize_text_field($_POST['end_'.$i]);
					$added_mappings_ranges++;
					update_site_option( 'mo_wpns_iprange_range_'.$added_mappings_ranges, $range );

				}
				else{
					$flag = 1;
					do_action('mowaf_show_message',MOWAF_Messages::showMessage('INVALID_IP'),'ERROR');
					return;
				}	
			}
        }
        
		if($added_mappings_ranges==0)
			update_site_option( 'mo_wpns_iprange_range_1','');
		update_site_option( 'mo_wpns_iprange_count', $added_mappings_ranges);
		if($flag == 0){
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('IP_PERMANENTLY_BLOCKED'),'SUCCESS');
		}		
	}

	function mowaf_handle_browser_blocking()
	{
		$nonce = sanitize_text_field( $_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-advance-blocking-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		isset($_POST['mo_wpns_block_chrome'])		? update_site_option( 'mo_wpns_block_chrome' 	,  sanitize_text_field($_POST['mo_wpns_block_chrome'] ))	: update_site_option( 'mo_wpns_block_chrome'  ,  false );
		isset($_POST['mo_wpns_block_firefox'])	? update_site_option( 'mo_wpns_block_firefox' 	, sanitize_text_field ($_POST['mo_wpns_block_firefox'] ))	: update_site_option( 'mo_wpns_block_firefox' ,  false );
		isset($_POST['mo_wpns_block_ie'])			? update_site_option( 'mo_wpns_block_ie' 		,  sanitize_text_field ($_POST['mo_wpns_block_ie'] ))	: update_site_option( 'mo_wpns_block_ie' 	 ,  false );
		isset($_POST['mo_wpns_block_safari'])		? update_site_option( 'mo_wpns_block_safari' 	,  sanitize_text_field ($_POST['mo_wpns_block_safari'] ))	: update_site_option( 'mo_wpns_block_safari'  ,  false );
		isset($_POST['mo_wpns_block_opera'])		? update_site_option( 'mo_wpns_block_opera' 		,  sanitize_text_field ($_POST['mo_wpns_block_opera'] ))	: update_site_option( 'mo_wpns_block_opera' 	 ,  false );
		isset($_POST['mo_wpns_block_edge'])		? update_site_option( 'mo_wpns_block_edge' 		, sanitize_text_field ( $_POST['mo_wpns_block_edge'] ))		: update_site_option( 'mo_wpns_block_edge' 	 ,  false );
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('CONFIG_SAVED'),'SUCCESS');
	}

	function mowaf_handle_htaccess_blocking()
	{
		$nonce =sanitize_text_field ( $_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-advance-blocking-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		$htaccess = isset($_POST['mo_wpns_enable_htaccess_blocking']) ? true : false;
		update_site_option( 'mo_wpns_enable_htaccess_blocking',  $htaccess);
		$mowaf_config = new MOWAF_Handler();
		if($htaccess)
		{
			$mowaf_config->add_htaccess_ips();
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('HTACCESS_ENABLED'),'SUCCESS');
		}
		else 
		{
			$mowaf_config->remove_htaccess_ips();
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('HTACCESS_DISABLED'),'ERROR');
		}
	}


	function mowaf_handle_user_agent_blocking()
	{
		$nonce = sanitize_text_field ($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-advance-blocking-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		$user_agent = isset($_POST['mo_wpns_enable_user_agent_blocking']) ? true : false;
		update_site_option( 'mo_wpns_enable_user_agent_blocking',  $user_agent);
		if($user_agent)
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('USER_AGENT_BLOCK_ENABLED'),'SUCCESS');
		else
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('USER_AGENT_BLOCK_DISABLED'),'ERROR');
	}


	function mowaf_handle_country_block()
	{
		$nonce = sanitize_text_field ($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-advance-blocking-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}		
		$countrycodes = "";
		foreach($_POST as $countrycode=>$value){
			if($countrycode!="option")
				$countrycodes .= sanitize_text_field ($countrycode).";";
		}
		update_site_option( 'mo_wpns_countrycodes', $countrycodes);
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('CONFIG_SAVED'),'SUCCESS');
	}

	function mowaf_handle_block_referrer()
	{
		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-advance-blocking-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		$referrers = "";
		foreach($_POST as $key => $value)
		{
			if(strpos($key, 'referrer_') !== false)
				if(!empty($value))
					$referrers .= sanitize_text_field ($value).";";
		}
		update_site_option( 'mo_wpns_referrers', $referrers);		
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('CONFIG_SAVED'),'SUCCESS');
	}
