<?php
	
	global $mowafutility,$mowaf_dirname;

	$template1	= "Hello,<br><br>The user with IP Address <b>##ipaddress##</b> has exceeded allowed trasaction limit on your website <b>".esc_html(get_bloginfo())."</b> and we have blocked his IP address for further access to website.<br><br>You can login to your WordPress dashaboard to check more details.<br><br>Thanks,<br>miniOrange";
	$template2	= "Hello ##username##,<br><br>Your account was logged in from new IP Address <b>##ipaddress##</b> on website <b>".esc_html(get_bloginfo())."</b>. Please <a href='mailto:".esc_url(MOWAF_Constants::SUPPORT_EMAIL)."'>contact us</a> if you don't recognise this activity.<br><br>Thanks,<br>".get_bloginfo();

	if(current_user_can( 'manage_options' )  && isset($_POST['option']) )
	{
		$option = sanitize_text_field($_POST['option']);
		switch($option)
		{
			case "mowaf_enable_ip_blocked_email_to_admin":
				mowaf_handle_notify_admin_on_ip_block();					break;
			case "mowaf_enable_unusual_activity_email_to_user":
				mowaf_handle_notify_unusual_activity();						break;
            case "mowaf_get_manual_email"	:
				mowaf_handle_admin_email();                                 break;
			case "custom_user_template":
				mowaf_handle_custom_template(sanitize_text_field($_POST['custom_user_template']));
																			break; 
			case "custom_admin_template":
				mowaf_handle_custom_template(null,sanitize_text_field($_POST['custom_admin_template']));	                           								break;
		}
	}

    if(!get_site_option("admin_email_address_status")|| get_site_option("admin_email_address") ==''){
     	update_site_option('mo_wpns_enable_ip_blocked_email_to_admin','0');
       	$notify_admin_on_ip_block = get_site_option('mo_wpns_enable_ip_blocked_email_to_admin') 	 ? "" : "unchacked";
   }
	$notify_admin_on_ip_block 	   = get_site_option('mo_wpns_enable_ip_blocked_email_to_admin') 	 ? "checked" : "";
	$notify_admin_unusual_activity = get_site_option('mo_wpns_enable_unusual_activity_email_to_user') ? "checked" : "";

	$template1					   = get_site_option('custom_admin_template') ? get_site_option('custom_admin_template') : $template1;
	$template_type1				   = 'custom_admin_template';
	$ip_blocking_template		   = array(
										'textarea_name' => 'custom_admin_template',
										'wpautop' => false
									);
	$fromEmail 					   = get_site_option('mo2f_email');
	$template2					   = get_site_option('custom_user_template') ? get_site_option('custom_user_template') : $template2;
	$template_type2				   = 'custom_user_template';
	$user_activity_template		   = array(
										'textarea_name' => 'custom_user_template',
										'wpautop' => false
									);
	include $mowaf_dirname . 'views'.DIRECTORY_SEPARATOR.'notification-settings.php';


    function mowaf_handle_admin_email()
	{
		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-notification-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		
        if(mowaf_validate_email(sanitize_email($_POST['admin_email_address']))){
			$admin_email_address_status = isset($_POST['admin_email_address']) ? '1' :'0';
			update_site_option('admin_email_address'        ,sanitize_email($_POST['admin_email_address']));
			update_site_option( 'admin_email_address_status', $admin_email_address_status);
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('EMAIL_SAVED'),'SUCCESS');
	    }else{
	    	do_action('mowaf_show_message',MOWAF_Messages::showMessage('INVALID_EMAIL'),'ERROR');
	    }
	}
	
	function mowaf_validate_email($str) {
     return (!preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $str)) ? FALSE : TRUE;
     }

	function mowaf_handle_notify_admin_on_ip_block()
	{
		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-notification-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		$enable_ip_blocked_email_to_admin = isset($_POST['enable_ip_blocked_email_to_admin']) ? true : false;
		update_site_option( 'mo_wpns_enable_ip_blocked_email_to_admin', $enable_ip_blocked_email_to_admin);

		if($enable_ip_blocked_email_to_admin)
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('NOTIFY_ON_IP_BLOCKED'),'SUCCESS');
		else
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('DONOT_NOTIFY_ON_IP_BLOCKED'),'ERROR');
	}

	function mowaf_handle_notify_unusual_activity()
	{
		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-notification-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		$enable_unusual_activity_email_to_user = isset($_POST['enable_unusual_activity_email_to_user']) ? true : false;
		update_site_option( 'mo_wpns_enable_unusual_activity_email_to_user', $enable_unusual_activity_email_to_user);
			
		if($enable_unusual_activity_email_to_user)
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('NOTIFY_ON_UNUSUAL_ACTIVITY'),'SUCCESS');
		else
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('DONOT_NOTIFY_ON_UNUSUAL_ACTIVITY'),'ERROR');
	}

	function mowaf_handle_custom_template($template1,$template2=null)
	{
		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'mowaf-notification-nonce' ) ){
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
	   			return;
	   		}
		if(!is_null($template1))
			update_site_option('custom_user_template', stripslashes($template1));

		if(!is_null($template2))
			update_site_option('custom_admin_template', stripslashes($template2));

		do_action('mowaf_show_message',MOWAF_Messages::showMessage('TEMPLATE_SAVED'),'SUCCESS');
	}