<?php

	global $mowaf_dirname;
	
	if(current_user_can( 'manage_options' )  && isset($_POST['option']))
	{
		$option = sanitize_text_field($_POST['option']);
		switch($option)
		{
			case "mowaf_send_query":
				mowaf_handle_support_form();	break;
		}
	}

	$current_user 	= wp_get_current_user();
	$email 			= get_site_option("mo2f_email");
	$phone 			= get_site_option("mo_wpns_admin_phone");

	
	if(empty($email))
		$email 		= $current_user->user_email;

	include $mowaf_dirname . 'views'.DIRECTORY_SEPARATOR.'support.php';

	function mowaf_handle_support_form()
	{	
		$nonce = 	sanitize_text_field($_POST['nonce']);	
		if(!wp_verify_nonce($nonce,'sendQueryNonce'))
		{
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('NONCE_ERROR'),'ERROR');
			exit;	
		}
		
		$email =	sanitize_email($_POST['query_email']);
		$query =	sanitize_text_field($_POST['query']);
		$phone =	sanitize_text_field($_POST['query_phone']);
		if( empty($email) || empty($query) )
		{
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('SUPPORT_FORM_VALUES'),'SUCCESS');
			return;
		}
		$contact_us = new MOWAF_cURL();
		$submited = $contact_us->submit_contact_us($email, $phone, $query);

		if(json_last_error() == JSON_ERROR_NONE) 
		{
			do_action('mowaf_show_message',MOWAF_Messages::showMessage('SUPPORT_FORM_SENT'),'SUCCESS');
			return;
		}
			
		do_action('mowaf_show_message',MOWAF_Messages::showMessage('SUPPORT_FORM_ERROR'),'ERROR');
	}