<?php
    global $mowafUtility,$mowaf_dirname;
	$mowaf_handler 	= new MOWAF_Handler();
	$sqlC 			= $mowaf_handler->get_blocked_attacks_count("SQL");
	$rceC 			= $mowaf_handler->get_blocked_attacks_count("RCE");
	$rfiC 			= $mowaf_handler->get_blocked_attacks_count("RFI");
	$lfiC 			= $mowaf_handler->get_blocked_attacks_count("LFI");
	$xssC 			= $mowaf_handler->get_blocked_attacks_count("XSS");
	$totalAttacks	= $sqlC+$lfiC+$rfiC+$xssC+$rceC;
	$manualBlocks 	= $mowaf_handler->get_manual_blocked_ip_count();
	$realTime		= 0;
	$countryBlocked = $mowaf_handler->get_blocked_countries();
	$IPblockedByWAF = $mowaf_handler->get_blocked_ip_waf();
	$totalIPBlocked = $manualBlocks+$realTime+$IPblockedByWAF;
	$mo_waf 		= get_site_option('WAFEnabled');
	if($mo_waf)
	{
		$mo_waf = false;
	}
	else
	{
		$mo_waf = true;	
	}
	
	if($totalIPBlocked>999)
	{
		$totalIPBlocked = strval(intval($totalIPBlocked/1000)).'k+';
	}
	
	if($totalAttacks>999)
	{
		$totalAttacks = strval(intval($totalAttacks/1000)).'k+';
	}
	update_site_option('mo2f_visit_waf',true);
	
	function mowaf_check_server_details()
	{
		$sapi 		= php_sapi_name();
		$serverType = '';
		if (stripos($_SERVER['SERVER_SOFTWARE'], 'apache') !== false) {
			$serverType	= 'apache';
		}
		else if (stripos($_SERVER['SERVER_SOFTWARE'], 'litespeed') !== false || $sapi == 'litespeed') {
			$serverType	= 'litespeed';
		}
		else if (strpos($_SERVER['SERVER_SOFTWARE'], 'nginx') !== false) {
			$serverType	= 'nginx';
		}
		else if (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS') !== false || strpos($_SERVER['SERVER_SOFTWARE'], 'ExpressionDevServer') !== false) {
			$serverType	= 'Microsoft-IIS';
		}
		return $serverType;
	}

	function mowaf_isApacheModPHP() {
		return function_exists('apache_get_modules');
	}
	function mowaf_isCGI($sapi) {
		return ! mowaf_isFastCGI() && stripos($sapi, 'cgi') !== false;
	}
	function  mowaf_isFastCGI($sapi) {
		return stripos($sapi, 'fastcgi') !== false || stripos($sapi, 'fpm-fcgi') !== false;
	}
	function mowaf_isApacheSuPHP($sapi) {
		return mowaf_isCGI($sapi) &&
			function_exists('posix_getuid') &&
			getmyuid() === posix_getuid();
	}
	function mowaf_check_mod_type()
	{
		$type = '';
		$sapi = php_sapi_name();
		if(mowaf_isApacheModPHP($sapi))
		{
			$type = 'modPHP';
		}
		else if(mowaf_isApacheSuPHP($sapi))
		{
			$type = 'suPHP';
		}
		else if( mowaf_isFastCGI($sapi))
		{
			$type = 'fcgi';
		}
		return $type;
	} 

	$server 			= mowaf_check_server_details();
	$apacheMod			= '';
	$downloadFilesNames	= '';
	$htaccess			= 0;
	$userIni 			= 0;

	if($server == 'apache')
	{
		$apacheMod = mowaf_check_mod_type();
	}
	switch ($server) {
		case 'apache':
			switch ($apacheMod) {
				case 'modPHP':
						$downloadFilesNames = 'Download .htaccess backup';
						$htaccess 			= 1;
					break;
				
				case 'suPHP':
						$downloadFilesNames = 'Download .htaccess and .user.ini backup';
						$htaccess 			= 1;
						$userIni 			= 1;
					break;
				case 'fcgi':
						$downloadFilesNames = 'Download .htaccess and .user.ini backup';
						$htaccess 			= 1;
						$userIni 			= 1;
					break;
				
				default:
					break;
			}
				
			break;
		case 'litespeed':
			$downloadFilesNames = 'Download .htaccess and .user.ini backup';
			$htaccess 			= 1;
			$userIni 			= 1;
			break;
		case 'Microsoft-IIS':
			$downloadFilesNames = 'Download .user.ini backup';
			$userIni 			= 1;
			break;
		case 'nginx':
			$downloadFilesNames = 'Download .user.ini backup';
			$userIni 			= 1;
			break;
		
		default:
			break;
	}



	
	include $mowaf_dirname . 'views'.DIRECTORY_SEPARATOR.'waf.php';