<?php
class MOWAF_ajax
{
	function __construct(){
		add_action( 'admin_init'  , array( $this, 'mowaf_login_security_ajax' ) );
	}

	function mowaf_login_security_ajax(){
		add_action( 'wp_ajax_mowaf_login_security', array($this,'mowaf_login_security') );
		if(isset($_POST['option']) and sanitize_text_field($_POST['option'])=='backup_htaccess_userIni')
			{
				ob_start();
	            $file_name='WAFBackup.zip';
	            $upload_dir = wp_upload_dir();
		        $file_path  = $upload_dir['basedir'].DIRECTORY_SEPARATOR.'miniOrangeBackup';
		        header("Pragma: public");
		        header("Expires: 0");
		        header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
		        header("Content-Type: application/zip");
		        header("Content-Disposition: attachment; filename=".$file_name);
		        header("Content-Transfer-Encoding: binary");
		        header("Content-Length: ".filesize($file_path.DIRECTORY_SEPARATOR.$file_name));
		        readfile($file_path.DIRECTORY_SEPARATOR.$file_name);
		        ob_flush();
		    	
			}
	}

		function mowaf_login_security(){
			$option = sanitize_text_field($_POST['mowaf_loginsecurity_ajax']);
			switch($option)
			{
				case "mowaf_bruteforce_form":
					$this->wpns_handle_bf_configuration_form();
					break;
				case "mowaf_save_captcha":
					$this->wpns_captcha_settings();
					break;
				case "mowaf_strong_password":
					$this->wpns_strong_password_settings();
					break;
				case 'mowaf_ManualIPBlock_form':
					$this->wpns_handle_IP_blocking();
					break;
				case 'mowaf_WhitelistIP_form':
					$this->wpns_whitelist_ip();
					break;
				case 'mowaf_waf_settings_form':
					$this->wpns_waf_settings_form(); 
					break;
				case 'mowaf_waf_rate_limiting_form':
					$this->wpns_waf_rate_limiting_form(); 
					break;	
				case 'mowaf_ip_lookup':
					$this->wpns_ip_lookup(); 	
					break;
			}
		}


	   function wpns_handle_bf_configuration_form(){

	   		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'wpns-brute-force' ) ){
	   			wp_send_json ('ERROR');
	   		}
	   		$brute_force        = sanitize_text_field($_POST['bf_enabled/disabled']);
	  		if($brute_force == 'true'){$brute_force = "on";}else if($brute_force == 'false') {$brute_force = "";}  
			$login_attempts 	= sanitize_text_field($_POST['allwed_login_attempts']);
			$blocking_type  	= sanitize_text_field($_POST['time_of_blocking_type']);
			$blocking_value 	= isset($_POST['time_of_blocking_val'])	 ? sanitize_text_field($_POST['time_of_blocking_val'])	: false;
			$show_login_attempts= sanitize_text_field($_POST['show_remaining_attempts']);
			if($show_login_attempts == 'true'){$show_login_attempts = "on";} else if($show_login_attempts == 'false') { $show_login_attempts = "";}
			if($brute_force == 'on' && $login_attempts == "" ){
				wp_send_json ('empty');
			}
	  		update_site_option( 'mo2f_enable_brute_force' 		, $brute_force 		  	  );
			update_site_option( 'mo2f_allwed_login_attempts'		, $login_attempts 		  );
			update_site_option( 'mo_wpns_time_of_blocking_type'	, $blocking_type 		  );
			update_site_option( 'mo_wpns_time_of_blocking_val' 	, $blocking_value   	  );
			update_site_option('mo2f_show_remaining_attempts' 	, $show_login_attempts    );
			if($brute_force == "on"){
				wp_send_json ('true');
			}
			else if($brute_force == ""){
				wp_send_json ('false');
			} 
			
		}
	function wpns_handle_IP_blocking()
	{
	
		global $mowaf_dirname;
		$nonce = sanitize_text_field($_POST['nonce']);	
		if(!wp_verify_nonce($nonce,'manualIPBlockingNonce'))
		{
			wp_send_json("NonceDidNotMatch");
		}
		else
		{
			$option = sanitize_text_field($_POST['option']);	 
			if($option == "mowaf_manual_block_ip")
			{
				global $mowafutility;			
				$ip = sanitize_text_field($_POST['IP']);
				if( $mowafutility->check_empty_or_null( $ip) )
				{
					wp_send_json("empty IP");
				} 
				if(!preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\z/',$ip))
				{
					wp_send_json("INVALID_IP_FORMAT");
				}
				else
				{
					$ipAddress 		= sanitize_text_field( $ip );
					$mowaf_config   = new MOWAF_Handler();
					$isWhitelisted 	= $mowaf_config->is_whitelisted($ipAddress);
					if(!$isWhitelisted)
					{
						if($mowaf_config->is_ip_blocked($ipAddress)){
							wp_send_json("already blocked");
						} 
						else{
							$mowaf_config->block_ip($ipAddress, MOWAF_Constants::BLOCKED_BY_ADMIN, true);
							wp_send_json("SUCCUSS");
						}
					}
					else
					{
						wp_send_json("IP_IN_WHITELISTED");
					}
				}
			}
			else if($option =="mowaf_unblock_ip")
			{
				$entryID = sanitize_text_field($_POST['id']);
				global $mowafutility;		
				if( $mowafutility->check_empty_or_null($entryID))
				{
					wp_send_json("UNKNOWN_ERROR");
				}
				else
				{
					$entryid 		= sanitize_text_field($entryID);
					$mowaf_config = new MOWAF_Handler();
					$mowaf_config->unblock_ip_entry($entryid);
					wp_send_json("SUCCESS");
				}
			}
		}
	}

	function wpns_whitelist_ip()
	{
		global $mowaf_dirname;
		$nonce = sanitize_text_field($_POST['nonce']);	
		if(!wp_verify_nonce($nonce,'IPWhiteListingNonce'))
		{
			wp_send_json("NonceDidNotMatch");
		}
		else
		{
			$option = sanitize_text_field($_POST['option']);	 
			if($option == "mowaf_whitelist_ip")
			{
				$ip = sanitize_text_field($_POST['IP']);
				global $mowafutility;
				if( $mowafutility->check_empty_or_null($ip))
				{
					wp_send_json("EMPTY IP");
				}
				if(!preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\z/',$ip))
				{
					wp_send_json("INVALID_IP");
				}
				else
				{
					$ipAddress = sanitize_text_field($ip);
					$mowaf_config = new MOWAF_Handler();
					if($mowaf_config->is_whitelisted($ipAddress))
					{
						wp_send_json("IP_ALREADY_WHITELISTED");
					}
					else
					{
						$mowaf_config->whitelist_ip($ip);
						$mowaf_handler 	= new MOWAF_Handler();
						$whitelisted_ips 	= $mowaf_handler->get_whitelisted_ips();
						wp_send_json("SUCCESS");
					}
				}
			}
			else if($option == "mowaf_remove_whitelist")
			{
				$entryID = sanitize_text_field($_POST['id'] );
				global $mowafutility;
				if( $mowafutility->check_empty_or_null($entryID))
				{
					wp_send_json("UNKNOWN_ERROR");
				}
				else
				{
					$entryid = sanitize_text_field($entryID);
					$mowaf_config = new MOWAF_Handler();
					$mowaf_config->remove_whitelist_entry($entryid);
					$mowaf_handler 	= new MOWAF_Handler();
					$whitelisted_ips 	= $mowaf_handler->get_whitelisted_ips();
					wp_send_json("SUCCESS");
				}
			}

		}
	}
	
	function wpns_ip_lookup()
	{

		$nonce = sanitize_text_field($_POST['nonce']);	
		if(!wp_verify_nonce($nonce,'IPLookUPNonce'))
		{
			wp_send_json("NonceDidNotMatch");
		}
		else
		{
			$ip  = sanitize_text_field($_POST['IP']);
	        if(!preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\z/',$ip))
			{
				wp_send_json("INVALID_IP_FORMAT");
			}
			else if(! filter_var($ip, FILTER_VALIDATE_IP)){
				wp_send_json("INVALID_IP");
			}
			wp_send_json("INVALID_IP");
		}
	}
	function wpns_waf_settings_form()
	{
		$nonce = sanitize_text_field($_POST['nonce']);	
		if(!wp_verify_nonce($nonce,'WAFsettingNonce'))
		{
			wp_send_json("NonceDidNotMatch");
		}

		$upload_dir = wp_upload_dir();
		$dir_name 	= $upload_dir['basedir'];
		
		if(!is_writable($dir_name))
		{
			update_site_option('NotWritable',1);		
		}

		$dir_name  .= DIRECTORY_SEPARATOR.'miniOrange';			
		$fileName 	= $dir_name.DIRECTORY_SEPARATOR.'mo-waf-config.php';
		$plugins_url =	plugins_url('includes/images/',dirname(__FILE__));
		$upload_dir 	= wp_upload_dir();
		if(!file_exists($fileName))
		{
			if(!file_exists($dir_name))
			mkdir($dir_name, 0777, true);
			$file 	 = fopen($fileName, "a+");
			$string  = "<?php".PHP_EOL;
			$string .= '$SQL=1;'.PHP_EOL;
			$string .= '$XSS=1;'.PHP_EOL;
			$string .= '$RCE=0;'.PHP_EOL;
			$string .= '$LFI=0;'.PHP_EOL;
			$string .= '$RFI=0;'.PHP_EOL;
			$string .= '$RateLimiting=1;'.PHP_EOL;
			$string .= '$RequestsPMin=120;'.PHP_EOL;
			$string .= '$actionRateL="ThrottleIP";'.PHP_EOL;			
			$string .= 'global $upload_path;'.PHP_EOL;
			$string .= '$upload_path="'.$upload_dir['basedir'].'";'.PHP_EOL;
			$string .= 'global $home_path;'.PHP_EOL;
			$string .= '$home_path="'.get_home_path().'";'.PHP_EOL;
			$string .= 'global $plugin_path;'.PHP_EOL;
			$string .= '$plugin_path="'.get_site_option("mowaf_plugin_path").'";'.PHP_EOL;
			
			fwrite($file, $string);
			fclose($file);
		}
		update_site_option('mowaf_upload_path',$upload_dir['basedir']);
		update_site_option('mowaf_plugins_url',$plugins_url);

			$optionValue = sanitize_text_field($_POST['optionValue']);
			switch ($optionValue) {
				case "SQL": 
					$this->saveAttack($fileName,'SQLInjection','SQL'); 	break;
				case "XSS": 
					$this->saveAttack($fileName,'XSSAttack','XSS'); 	break;
				case "RCE": 
					$this->saveAttack($fileName,'RCEAttack','RCE'); 	break;
				case "RFI": 
					$this->saveAttack($fileName,'RFIAttack','RFI'); 	break;
				case "LFI": 
					$this->saveAttack($fileName,'LFIAttack','LFI'); 	break;
				case "WAF": 
					$this->saveWAF();			break;
				case "HWAF": 
					$this->saveHWAF();			break;
				case "backupHtaccess":
					$this->backupHtaccess();	break;
				case "limitAttack":
					$this->limitAttack();		break;
				default:
					break;
			}	

	}

    function wpns_waf_rate_limiting_form()
	{
		$nonce = sanitize_text_field($_POST['nonce']);	
		if(!wp_verify_nonce($nonce,'RateLimitingNonce'))
		{
			wp_send_json( "NonceDidNotMatch");
			
		}
		else
		{
			if(get_site_option('WAFEnabled') != 1)
			{
				wp_send_json("WAFNotEnabled");
				
			}

			if($_POST['Requests']!='')
			{
				if(is_numeric(sanitize_text_field($_POST['Requests'])))
				{
				$upload_dir=wp_upload_dir();
				$fileName = $upload_dir['basedir'].DIRECTORY_SEPARATOR.'miniOrange'.DIRECTORY_SEPARATOR.'mo-waf-config.php';
				
				$file = file_get_contents($fileName);
				$data = $file;
			
				$req  =	sanitize_text_field($_POST['Requests']);
				if($req >1)
				{
					update_site_option('Rate_request',$req);
					if(isset($_POST['rateCheck']))
					{
						if(sanitize_text_field($_POST['rateCheck']) == 'on')
						{
							update_site_option('Rate_limiting','1');
							$return ="RateEnabled";
							if(strpos($file, 'RateLimiting')!=false)
							{
								$file = str_replace('$RateLimiting=0;', '$RateLimiting=1;', $file);
								$data = $file;
								file_put_contents($fileName,$file);	
								
							}
							else
							{
								$file .= '$RateLimiting=1;'.PHP_EOL;
								file_put_contents($fileName,$file);
								$data = $file;
							}
						

						}
					}	
					else
					{
						update_site_option('Rate_limiting','0');
						$return = "Ratedisabled";
						if(strpos($file, 'RateLimiting')!=false)
						{
							$file = str_replace('$RateLimiting=1;', '$RateLimiting=0;', $file);
							$data = $file;
							file_put_contents($fileName,$file);	
						}
						else
						{
							$content = explode('?>', $file);
							$file = $content[0];
							$file .= PHP_EOL;
							$file .= '$RateLimiting=0;'.PHP_EOL;
							$file .='?>';
							file_put_contents($fileName,$file);
							$data = $file;
						}

					}				

					
					$file = $data;
					if(strpos($file, 'RequestsPMin')!=false)
					{
						$content = explode(PHP_EOL, $file);
						$con = '';
						$len =  sizeof($content);
						
						for($i=0;$i<$len;$i++)
						{
							if(strpos($content[$i], 'RequestsPMin')!=false)
							{
								$con.='$RequestsPMin='.$req.';'.PHP_EOL;
							}
							else
							{
								$con .= $content[$i].PHP_EOL;
							}
						}
					
						file_put_contents($fileName,$con);
						$data = $con;
						
					}

					else
					{
						$file .= '$RequestsPMin='.$req.';'.PHP_EOL;
						file_put_contents($fileName,$file);
						$data = $file;
					}
				
					if(sanitize_text_field($_POST['actionOnLimitE'])=='BlockIP' || sanitize_text_field($_POST['actionOnLimitE'])== 1)
					{
						update_site_option('actionRateL',1);

						$file = $data;
						if(strpos($file, 'actionRateL')!=false)
						{
							$content = explode(PHP_EOL, $file);
							$con = '';
							foreach ($content as $line => $lineV) {
								if(strpos($lineV, 'actionRateL')!=false)
								{
									$con.='$actionRateL="BlockIP";'.PHP_EOL;
								}
								else
								{
									$con .= $lineV.PHP_EOL;
								}
							}
							file_put_contents($fileName,$con);	
						}
						else
						{
							$file .= '$actionRateL="BlockIP";'.PHP_EOL;
							file_put_contents($fileName,$file);
							$file = $data;
						}
					}
					else if(sanitize_text_field($_POST['actionOnLimitE'])=='ThrottleIP' || sanitize_text_field($_POST['actionOnLimitE']) == 0)
					{

						$file = $data;
						update_site_option('actionRateL',0);
						if(strpos($file, 'actionRateL')!=false)
						{
							$content = explode(PHP_EOL, $file);
							$con = '';
							foreach ($content as $line => $lineV) {
								if(strpos($lineV, 'actionRateL')!=false)
								{
									$con.='$actionRateL="ThrottleIP";'.PHP_EOL;
								}
								else
								{
									$con .= $lineV.PHP_EOL;
								}
							}
							file_put_contents($fileName,$con);	
						}
						else
						{
							$file .= '$actionRateL="ThrottleIP";'.PHP_EOL;
							file_put_contents($fileName,$file);
						}	
					}

			}
			wp_send_json($return);
		}
		
			
			
		}
		wp_send_json("Error");
		}
		
		
	}
	function add_mo_waf_config_cont($string,$value)
	{
		$upload_dir = wp_upload_dir();
		$fileName = $upload_dir['basedir'].DIRECTORY_SEPARATOR.'miniOrange'.DIRECTORY_SEPARATOR.'mo-waf-config.php';
		$file 	  = file_get_contents($fileName);
		if(strpos($file, $string)!=false)
		{
			$content 	= explode(PHP_EOL, $file);
			$con 		= '';
			foreach ($content as $line => $lineV) {
				if(strpos($lineV, $string)!=false)
				{
					$con.='$'.$string.'='.$value.';'.PHP_EOL;
				}
				else
				{
					$con .= $lineV.PHP_EOL;
				}
			}
			file_put_contents($fileName,$con);	
		}
		else
		{
			$file .= '$'.$string.'='.$value.';'.PHP_EOL;
			file_put_contents($fileName,$file);
		}
		$file = file_get_contents($fileName);
		$file = preg_replace('/^[ \t]*[\r\n]+/m', '', $file);
		file_put_contents($fileName, $file);		
	}

	private function saveWAF()
	{	
		if(isset($_POST['pluginWAF']))
		{
			if(sanitize_text_field($_POST['pluginWAF'])=='on')
			{
				update_site_option('WAF','PluginLevel');
				update_site_option('WAFEnabled','1');
				wp_send_json("PWAFenabled");
			}
		}
		else
		{
				update_site_option('WAFEnabled','0');
				update_site_option('WAF','wafDisable');
				update_site_option('SQLInjection',0);
				update_site_option('XSSAttack',0);
				update_site_option('LFIAttack',0);
				$this->add_mo_waf_config_cont('SQL',0);
				$this->add_mo_waf_config_cont('XSS',0);
				$this->add_mo_waf_config_cont('LFI',0);
				wp_send_json("PWAFdisabled");
		}
	}

	private function isApacheModPHP() {
		return function_exists('apache_get_modules');
	}
	private function isCGI($sapi) {
		return !$this->isFastCGI() && stripos($sapi, 'cgi') !== false;
	}
	private function isFastCGI($sapi) {
		return stripos($sapi, 'fastcgi') !== false || stripos($sapi, 'fpm-fcgi') !== false;
	}
	private function isApacheSuPHP($sapi) {
		return $this->isCGI($sapi) &&
			function_exists('posix_getuid') &&
			getmyuid() === posix_getuid();
	}
	private function check_mod_type()
	{
		$type = '';
		$sapi = php_sapi_name();
		if($this->isApacheModPHP($sapi))
		{
			$type = 'modPHP';
		}
		else if($this->isApacheSuPHP($sapi))
		{
			$type = 'suPHP';
		}
		else if($this->isFastCGI($sapi))
		{
			$type = 'fcgi';
		}
		return $type;
	} 
	private function check_server_details()
	{
		$sapi 		= php_sapi_name();
		$serverType = '';
		if (stripos($_SERVER['SERVER_SOFTWARE'], 'apache') !== false) {
			$serverType	= 'apache';
		}
		else if (stripos($_SERVER['SERVER_SOFTWARE'], 'litespeed') !== false || $sapi == 'litespeed') {
			$serverType	= 'litespeed';
		}
		else if (strpos($_SERVER['SERVER_SOFTWARE'], 'nginx') !== false) {
			$serverType	= 'nginx';
		}
		else if (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS') !== false || strpos($_SERVER['SERVER_SOFTWARE'], 'ExpressionDevServer') !== false) {
			$serverType	= 'Microsoft-IIS';
		}
		return $serverType;
	}
	private function addAppendContent()
	{
		$dir_name   = get_home_path();
		$file_name  = $dir_name.DIRECTORY_SEPARATOR.'.htaccess';
		$mocheck 	= $dir_name.DIRECTORY_SEPARATOR.'mo-check.php';
		$wafFile 	= get_site_option('mowaf_plugin_path');
		$wafFile 	= str_replace('\/', '\\\\', $wafFile);
		$wafFile   .= 'handler'.DIRECTORY_SEPARATOR.'WAF'.DIRECTORY_SEPARATOR.'mo-waf.php'; 
		$wafFile 	= str_replace('\\', '\\\\', $wafFile);	 	
	 	$file 		= file_get_contents($file_name);
	 	

	 	$cont 		 = 	$file.PHP_EOL.'# BEGIN miniOrange WAF'.PHP_EOL;
	 	$cont 		.= '<IfModule mod_php5.c>'.PHP_EOL;
	 	$cont 		.= 'php_value auto_prepend_file '.$mocheck.PHP_EOL;
	 	$cont  		.= '</IfModule>'.PHP_EOL.'<IfModule mod_php7.c>'.PHP_EOL;
	 	$cont 		.= 'php_value auto_prepend_file '.$mocheck.PHP_EOL;
	 	$cont  		.= '</IfModule>'.PHP_EOL;
	 	$cont 		.= '# END miniOrange WAF'.PHP_EOL;
	 	file_put_contents($file_name, $cont);

		$file 			= fopen($mocheck, 'w+');
		$string   		= '<?php'.PHP_EOL;
		$string    		.= 'if(file_exists("'.$wafFile.'"))'.PHP_EOL;
		$string    		.= 'include_once("'.$wafFile.'");'.PHP_EOL;
		$string    		.= '?>'.PHP_EOL;
					
		fwrite($file, $string);
		fclose($file);

		$filecontent = file_get_contents($file_name);

		if(strpos($filecontent,'mo-check.php')!=false)
		{
			return 1;
		}
		else
		{
			return 0;
		}
	}
	private function removeAppendContent()
	{
		if(isset($_POST['pluginWAF']))
		{
			if(sanitize_text_field($_POST['pluginWAF']) == 'on')
			{
				update_site_option('WAFEnabled',1);
				update_site_option('WAF','PluginLevel');
			}
		}
		else
			update_site_option('WAFEnabled',0);
		$dir_name 	=  dirname(__FILE__);
		$dirN 		= $dir_name;
		$dirN 		= str_replace('\\', '/', $dirN);
		$dirN 		= explode('wp-content', $dirN);
		$dir_name1 	= explode('wp-content', $dir_name);
		$dir_name 	= $dir_name1[0];
		$dir_name1 	= $dir_name1[0];
		$dir_name00 = $dir_name1; 
		$dir_name1 .='.htaccess';
	 	$file 		=  file_get_contents($dir_name1);

	 	$cont 	 = '# BEGIN miniOrange WAF'.PHP_EOL;
	 	$cont 	.= '<IfModule mod_php5.c>'.PHP_EOL;
	 	$cont 	.= 'php_value auto_prepend_file '.$dir_name00.'mo-check.php'.PHP_EOL;
	 	$cont  	.= '</IfModule>'.PHP_EOL.'<IfModule mod_php7.c>'.PHP_EOL;
	 	$cont 	.= 'php_value auto_prepend_file '.$dir_name00.'mo-check.php'.PHP_EOL;
	 	$cont  	.= '</IfModule>'.PHP_EOL;
	 	$cont 	.= '# END miniOrange WAF'.PHP_EOL;
	 	$file 	 = str_replace($cont,'',$file);
		file_put_contents($dir_name1, $file);

		$filecontent = file_get_contents($dir_name1);
		if(strpos($filecontent,'mo-check.php')==false)
		{
			return 1;
		}
		else
		{
			return 0;
		}
	}
	private function addFileContent()
	{
		$dir_name 	= get_home_path();
		$file_name  = $dir_name.DIRECTORY_SEPARATOR.'.htaccess';
		$mocheck    = $dir_name.DIRECTORY_SEPARATOR.'mo-check.php';
	 	$file 		= file_get_contents($file_name);
	 	$cont 		= $file.'';

	 	if(strpos($file,'# BEGIN miniOrange WAF')==false)
	 	{
	 		$cont .= '# BEGIN miniOrange WAF'.PHP_EOL;
	 	}
	 	$cont 	.= '<Files ".user.ini">'.PHP_EOL.'<IfModule mod_authz_core.c>'.PHP_EOL.'Require all denied'.PHP_EOL.'</IfModule>'.PHP_EOL;
	 	$cont 	.= '<IfModule !mod_authz_core.c>'.PHP_EOL.'Order deny,allow'.PHP_EOL.'Deny from all'.PHP_EOL.'</IfModule>'.PHP_EOL.'</Files>'.PHP_EOL;
	 	if(strpos($file,'# BEGIN miniOrange WAF')==false)
	 	{
	 		$cont 	.= '# END miniOrange WAF'.PHP_EOL;
	 	}
	 	file_put_contents($file_name, $cont);
	 	

		$file 			 = fopen($mocheck, 'w+');
		$wafFile 		 = plugin_dir_path(__FILE__);		
		$wafFile 	= str_replace('/', '\\\\', $wafFile);
		$wafFile 		 = $wafFile.DIRECTORY_SEPARATOR.'handler'.DIRECTORY_SEPARATOR.'WAF'.DIRECTORY_SEPARATOR.'mo-waf.php';	
		$wafFile 		 = str_replace('\\', '\\\\', $wafFile);
		$string   		 = '<?php'.PHP_EOL;
		$string    		.= 'if(file_exists("'.$wafFile.'"))'.PHP_EOL;
		$string    		.= 'include_once("'.$wafFile.'");'.PHP_EOL;
		$string    		.= '?>'.PHP_EOL;
					
		fwrite($file, $string);
		fclose($file);
		$filecontent     = file_get_contents($file_name);
		if(strpos($filecontent,'miniOrange WAF')!=false)
		{
			return 1;
		}
		else
		{
			return 0;
		}


	}
	private function removeFileContent()
	{
		if(isset($_POST['pluginWAF']))
		{
			if(sanitize_text_field($_POST['pluginWAF']) == 'on')
			{
				update_site_option('WAFEnabled',1);
				update_site_option('WAF','PluginLevel');
			}
		}
		else
			update_site_option('WAFEnabled',0);
		$dir_name 	=  dirname(__FILE__);
		$dirN 		= $dir_name;
		$dirN 		= str_replace('\\', '/', $dirN);
		$dirN 		= explode('wp-content', $dirN);
		$dir_name1 	= explode('wp-content', $dir_name);
		$dir_name 	= $dir_name1[0];
		$dir_name1 	= str_replace('\\', '/', $dir_name1[0]);
		$dir_name00 = $dir_name1; 
		$dir_name1 .='.htaccess';
	 	$file 		=  file_get_contents($dir_name1);

	 	$cont 		= '';
	 	if(strpos($file,'# BEGIN miniOrange WAF')!=false)
	 	{
	 		$cont = '# BEGIN miniOrange WAF'.PHP_EOL;
	 	}
	 	$cont 	.= '<Files ".user.ini">'.PHP_EOL.'<IfModule mod_authz_core.c>'.PHP_EOL.'Require all denied'.PHP_EOL.'</IfModule>'.PHP_EOL;
	 	$cont 	.= '<IfModule !mod_authz_core.c>'.PHP_EOL.'Order deny,allow'.PHP_EOL.'Deny from all'.PHP_EOL.'</IfModule>'.PHP_EOL.'</Files>'.PHP_EOL;
	 	if(strpos($file,'# BEGIN miniOrange WAF')!=false)
	 	{
	 		$cont 	.= '# END miniOrange WAF'.PHP_EOL;
	 	}
	 	$file 	 = str_replace($cont,'',$file);
		file_put_contents($dir_name1, $file);

		$filecontent = file_get_contents($dir_name1);
		if(strpos($filecontent,'mo-check.php')==false)
		{
			return 1;
		}
		else
		{
			return 0;	
		}
	}
	private function addUseriniContent()
	{
		$dir_name 		= get_home_path();
		$fileName 		= $dir_name.DIRECTORY_SEPARATOR.'.user.ini';
		$file 			= fopen($fileName, 'a+');
		
		$filepath  	    = $dir_name.DIRECTORY_SEPARATOR.'mo-check.php';
		$string 		= 'auto_prepend_file = '.$filepath;

		fwrite($file, $string);
		fclose($file);

		$filecontent  = file_get_contents($fileName);
		if(strpos($filecontent,'mo-check')!=false)
		{
			return 1;
		}
		else
		{
			return 0;
		}

		
	}
	private function removeUseriniContent()
	{
		$dir_name 		= get_home_path();
		$fileName 		= $dir_name.DIRECTORY_SEPARATOR.'.user.ini';
		$fullContent 	= file_get_contents($fileName);

		$filepath  	    = $dir_name.DIRECTORY_SEPARATOR.'mo-check.php';
		$string 		= 'auto_prepend_file = '.$filepath;
		
		$string 		= str_replace($string, '', $fullContent);

		file_put_contents($fileName, $string);

		$filecontent  = file_get_contents($fileName);
		if(strpos($filecontent,'auto_prepend_file')==false)
		{
			return 1;
		}
		else
		{
			return 0;
		}

	}
	
	private function EnableWAFapacheModPHP()
	{
		$r1 = $this->addAppendContent();
		$r2 = $this->addFileContent();
		if($r1 == 1 and $r2 == 1)
		{	
			update_site_option('WAF','HtaccessLevel');
			update_site_option('WAFEnabled','1');
			exit;
		}
		else
		{
			wp_send_json("HWAFEnabledFailed");
		}
	}
	private function DisableWAFapacheModPHP()
	{
		$r1 = $this->removeAppendContent();
		$r2 = $this->removeFileContent();
		if($r1 == 1 and $r2 == 1)
		{
			if(isset($_POST['pluginWAF']))
			{
				if(sanitize_text_field($_POST['pluginWAF']) == 'on')
				{
					update_site_option('WAFEnabled',1);
					update_site_option('WAF','PluginLevel');
				}
			}
			else
				update_site_option('WAF','wafDisable');

			$pluginWAF = isset($_POST['pluginWAF']) ?  sanitize_text_field($_POST['pluginWAF']) : '';
			if(isset($pluginWAF)  and $pluginWAF == 'on')
			{

			}
			else
			{
				update_site_option('SQLInjection',0);
				update_site_option('XSSAttack',0);
				update_site_option('LFIAttack',0);
				$this->add_mo_waf_config_cont('SQL',0);
				$this->add_mo_waf_config_cont('XSS',0);
				$this->add_mo_waf_config_cont('LFI',0);
				
				wp_send_json( "HWAFdisabled");
				exit;
			}
		}
		else
		{
			wp_send_json( "HWAFdisabledFailed");
			exit;
		}
	}
	private function EnableWAFapacheSuPHP()
	{
		$r1 = $this->addUseriniContent();
		$r2 = $this->addFileContent();
		if($r1 == 1 and $r2 == 1)
		{	
			update_site_option('WAF','HtaccessLevel');
			update_site_option('WAFEnabled','1');
			exit;
		}
		else
		{
			wp_send_json( "HWAFEnabledFailed" );
			exit;
		}
	}
	private function DisableWAFapacheSuPHP()
	{
		$r1 = $this->removeUseriniContent();
		$r2 = $this->removeFileContent();
		if($r1 == 1 and $r2 == 1)
		{	
			if(isset($_POST['pluginWAF']))
			{
				if(sanitize_text_field($_POST['pluginWAF']) == 'on')
				{
					update_site_option('WAFEnabled',1);
					update_site_option('WAF','PluginLevel');
				}
			}
			else
				update_site_option('WAF','wafDisable');
			$pluginWAF = sanitize_text_field($_POST['pluginWAF']);
			if(isset($pluginWAF)  and $pluginWAF == 'on')
			{

			}
			else
			{
				update_site_option('SQLInjection',0);
				update_site_option('XSSAttack',0);
				update_site_option('LFIAttack',0);
				$this->add_mo_waf_config_cont('SQL',0);
				$this->add_mo_waf_config_cont('XSS',0);
				$this->add_mo_waf_config_cont('LFI',0);
				
				wp_send_json( "HWAFdisabled");
				exit;
			}
			exit;
		}
		else
		{
			wp_send_json("HWAFdisabledFailed");
			exit;
		}
	}
	private function EnableWAFapacheFcgi()
	{
		$this->EnableWAFapacheSuPHP();	
	}
	private function DisableWAFapacheFcgi()
	{
		$this->DisableWAFapacheSuPHP();
	}
	private function EnableWAFlitespeed()
	{
		
		$dir_name 	= get_home_path();
		$mocheck 	= $dir_name.DIRECTORY_SEPARATOR.'mo-check.php';
		$file_name   = $dir_name.DIRECTORY_SEPARATOR.'.htaccess';
	 	$file 		= file_get_contents($file_name);
	 	

	 	$cont 	 = $file.PHP_EOL.'# BEGIN miniOrange WAF'.PHP_EOL;
	 	$cont 	.= '<IfModule LiteSpeed>'.PHP_EOL;
	 	$cont 	.= 'php_value auto_prepend_file '.$mocheck.PHP_EOL;
	 	$cont  	.= '</IfModule>'.PHP_EOL.'<IfModule lsapi_module>'.PHP_EOL;
	 	$cont 	.= 'php_value auto_prepend_file '.$mocheck.PHP_EOL;
	 	$cont  	.= '</IfModule>'.PHP_EOL;
	 	$cont 	.= '# END miniOrange WAF'.PHP_EOL;
	 	file_put_contents($file_name, $cont);

		$filepath 		 = $mowaf_dirname;
		$filepath 		.= DIRECTORY_SEPARATOR.'handler'.DIRECTORY_SEPARATOR.'WAF'.DIRECTORY_SEPARATOR.'mo-waf.php';	
		$string   		 = '<?php'.PHP_EOL;
		$string    		.= 'if(file_exists("'.$filepath.'"))'.PHP_EOL;
		$string    		.= 'include_once("'.$filepath.'");'.PHP_EOL;
		$string    		.= '?>'.PHP_EOL;
					
		fwrite($mocheck, $string);
		fclose($mocheck);
		$r1 = 0;
		$filecontent 	= file_get_contents($file_name);
		if(strpos($filecontent,'mo-check.php')!=false)
		{
			$r1 = 1;
		}
		
		$r2 = $this->addUseriniContent();
		$r3 = $this->addFileContent();
		if($r1 == 1 && $r2 == 1 && $r3 ==1)
		{
			update_site_option('WAF','HtaccessLevel');
			update_site_option('WAFEnabled','1');
			exit;
		}
		else
		{
			wp_send_json( "HWAFEnabledFailed");
			exit;
		}
		
	}
	private function DisableWAFlitespeed()
	{
		if(isset($_POST['pluginWAF']))
		{
			if(sanitize_text_field($_POST['pluginWAF']) == 'on')
			{
				update_site_option('WAFEnabled',1);
				update_site_option('WAF','PluginLevel');
			}
		}
		else
			update_site_option('WAFEnabled',0);
		$dir_name 	= get_home_path();
		$file_name  = $dir_name.DIRECTORY_SEPARATOR.'.htaccess';
		$mocheck 	= $dir_name.DIRECTORY_SEPARATOR.'mo-check.php';
	 	$file 		=  file_get_contents($file_name);

	 	$cont 	 = $file.PHP_EOL.'# BEGIN miniOrange WAF'.PHP_EOL;
	 	$cont 	.= '<IfModule LiteSpeed>'.PHP_EOL;
	 	$cont 	.= 'php_value auto_prepend_file '.$mocheck.PHP_EOL;
	 	$cont  	.= '</IfModule>'.PHP_EOL.'<IfModule lsapi_module>'.PHP_EOL;
	 	$cont 	.= 'php_value auto_prepend_file '.$mocheck.PHP_EOL;
	 	$cont  	.= '</IfModule>'.PHP_EOL;
	 	$cont 	.= '# END miniOrange WAF'.PHP_EOL;
	 	$file 	 = str_replace($cont,'',$file);
		file_put_contents($file_name, $file);

		$filecontent = file_get_contents($file_name);
		$r1  		 = 0;
		if(strpos($filecontent,'mo-check.php')==false)
		{
			$r1 = 1;
		}
		$r2 = $this->removeUseriniContent();
		$r3 = $this->removeFileContent();
		if($r1 == 1 and $r2 == 1 and $r3 == 1)
		{	
			if(isset($_POST['pluginWAF']))
			{
				if(sanitize_text_field($_POST['pluginWAF']) == 'on')
				{
					update_site_option('WAFEnabled',1);
					update_site_option('WAF','PluginLevel');
				}
			}
			else
				update_site_option('WAF','wafDisable');

			$pluginWAF = sanitize_text_field($_POST['pluginWAF']);
			if(isset($pluginWAF)  and $pluginWAF == 'on')
			{

			}
			else
			{
				update_site_option('SQLInjection',0);
				update_site_option('XSSAttack',0);
				update_site_option('LFIAttack',0);
				$this->add_mo_waf_config_cont('SQL',0);
				$this->add_mo_waf_config_cont('XSS',0);
				$this->add_mo_waf_config_cont('LFI',0);
				
				wp_send_json( "HWAFdisabled");
			}
		}
		else
		{
			wp_send_json("HWAFdisabledFailed");
		}

	}
	private function AddmoCheckFile()
	{
		$dir_name   = get_home_path();
		$fileName   = $dir_name.DIRECTORY_SEPARATOR.'mo-check.php';
		$file 		= fopen($fileName, 'w+');
		$dir_name 	= $mowaf_dirname;
		$filepath 	= $dir_name.DIRECTORY_SEPARATOR.'handler'.DIRECTORY_SEPARATOR.'WAF'.DIRECTORY_SEPARATOR.'mo-waf.php';	

		$string   = '<?php'.PHP_EOL;
		$string  .= 'if(file_exists("'.$filepath.'"))'.PHP_EOL;
		$string  .= 'include_once("'.$filepath.'");'.PHP_EOL;
		$string  .= "\$"."GLOBALS['MOWAF'] = 'Enabled';".PHP_EOL;
		$string  .= '?>'.PHP_EOL;
					
		fwrite($file, $string);
		fclose($file);

	}
	private function EnableWAFnginx()
	{
		$r1 = $this->addUseriniContent();
		$this->AddmoCheckFile();	
		if($r1 == 1)
		{
			update_site_option('WAF','HtaccessLevel');
			update_site_option('WAFEnabled','1');
			exit;
		}
		else
		{
			wp_send_json("HWAFEnabledFailed");
		}
		
	}
	private function DisableWAFnginx()
	{
		$r1 = $this->removeUseriniContent();
		if($r1 == 1)
		{
			$pluginWAF = sanitize_text_field($_POST['pluginWAF']);
			if(isset($pluginWAF)  and $pluginWAF == 'on')
			{
				update_site_option('WAFEnabled',1);
				update_site_option('WAF','PluginLevel');

			}
			else
			{
				update_site_option('WAF','wafDisable');
				update_site_option('SQLInjection',0);
				update_site_option('XSSAttack',0);
				update_site_option('LFIAttack',0);
				$this->add_mo_waf_config_cont('SQL',0);
				$this->add_mo_waf_config_cont('XSS',0);
				$this->add_mo_waf_config_cont('LFI',0);
				
				 wp_send_json("HWAFdisabled");
				exit;
			}
		}
		else
		{
			wp_send_json("HWAFdisabledFailed");
		}	
		
	}
	private function EnableWAFmicrosoftIIS()
	{
		$this->EnableWAFnginx();
	}
	private function DisableWAFmicrosoftIIS()
	{
		$this->DisableWAFnginx();
	}
	private function saveHWAF()
	{
		if(!function_exists('mysqli_connect'))
		{
			wp_send_json( "mysqliDoesNotExit");
		}

		$server 	= $this->check_server_details();
		$apacheMod	= '';
		if($server == 'apache')
		{
			$apacheMod = $this->check_mod_type();
		}
		if(isset($_POST['htaccessWAF']))
		{
			if(sanitize_text_field($_POST['htaccessWAF'])=='on')
			{
				switch ($server) {
				case 'apache':
					switch ($apacheMod) {
						case 'modPHP':
								$this->EnableWAFapacheModPHP();
							break;
						
						case 'suPHP':
								$this->EnableWAFapacheSuPHP();
							break;
						case 'fcgi':
								$this->EnableWAFapacheFcgi();
							break;
						
						default:
							break;
					}
						
					break;
				case 'litespeed':
					$this->EnableWAFlitespeed();
					break;
				case 'Microsoft-IIS':
					$this->EnableWAFmicrosoftIIS();
					break;
				case 'nginx':
					$this->EnableWAFnginx();
					break;
				
				default:
						break;
				}

			}
		}
		else
		{
			switch ($server) {
			case 'apache':
				switch ($apacheMod) {
					case 'modPHP':
							$this->DisableWAFapacheModPHP();
						break;
					
					case 'suPHP':
							$this->DisableWAFapacheSuPHP();
						break;
					case 'fcgi':
							$this->DisableWAFapacheFcgi();
						break;
					
					default:
						break;
				}
					
				break;
			case 'litespeed':
				$this->DisableWAFlitespeed();
				break;
			case 'Microsoft-IIS':
				$this->DisableWAFmicrosoftIIS();
				break;
			case 'nginx':
				$this->DisableWAFnginx();
				break;
			
			default:
					break;
			}
		}

	}
	

	
	private function saveAttack($fileName,$type,$name)
	{
		$file  = file_get_contents($fileName);
		$value = empty($_POST[$name]) ? 0 : 1;
		
		$opValue = $value == 1 ? 0 : 1;
		update_site_option($type,$value);
		
		if(strpos($file, $name)!=false)
		{
			$file = str_replace('$'.$name.'='.$opValue.';', '$'.$name.'='.$value.';', $file);
			file_put_contents($fileName,$file);	
		}
		else
		{
			$file .= '$'.$name.'='.$value.';'.PHP_EOL;
			file_put_contents($fileName,$file);
		}
		if($value == 1 )
		{
			wp_send_json($name."enable");
		}
		else
		{
			wp_send_json($name."disable");
		}

	}
	private function saveRateL()
	{
		$time = sanitize_text_field($_POST['time']);
		$req  =	sanitize_text_field($_POST['req']);
		if($time!='' && $req!='')
		{
			if(is_numeric($time) && is_numeric($req))
			{
				$dir_name =  dirname(__FILE__);
				$dir_name1 = explode('wp-content', $dir_name);
				$dir_name = $dir_name1[0];
				$filepath = str_replace('\\', '/', $dir_name1[0]);
				$fileName = $filepath.'/wp-includes/mo-waf-config.php';
				
				$file = file_get_contents($fileName);
				$data = $file;
				if($time>0 && $req >0)
				{
					update_site_option('Rate_time',$time);
					update_site_option('Rate_request',$req);
					update_site_option('Rate_limiting','1');

					if(strpos($file, 'RateLimiting')!=false)
					{
						$file = str_replace('$RateLimiting=0;', '$RateLimiting=1;', $file);
						$data = $file;
						file_put_contents($fileName,$file);	
					}
					else
					{
						$content = explode('?>', $file);
						$file = $content[0];
						$file .= PHP_EOL;
						$file .= '$RateLimiting=1;'.PHP_EOL;
						$file .='?>';
						file_put_contents($fileName,$file);
						$data = $file;
					}
					
					$file = $data;
					if(strpos($file, 'RequestsPMin')!=false)
					{
						$content = explode(PHP_EOL, $file);
						$con = '';
						$len =  sizeof($content);
						
						for($i=0;$i<$len;$i++)
						{
							if(strpos($content[$i], 'RequestsPMin')!=false)
							{
								$con.='$RequestsPMin='.$req.';'.PHP_EOL;
							}
							else
							{
								$con .= $content[$i].PHP_EOL;
							}
						}
						
						file_put_contents($fileName,$con);
						$data = $con;
						
					}

					else
					{
						$content = explode('?>', $file);
						$file = $content[0];
						$file .= PHP_EOL;
						$file .= '$RequestsPMin='.$req.';'.PHP_EOL;
						$file .='?>';
						file_put_contents($fileName,$file);
						$data = $file;
					}
				

					
					if(sanitize_text_field($_POST['action'])=='BlockIP')
					{
						update_site_option('actionRateL',1);

						$file = $data;
						if(strpos($file, 'actionRateL')!=false)
						{
							$content = explode(PHP_EOL, $file);
							$con = '';
							foreach ($content as $line => $lineV) {
								if(strpos($lineV, 'actionRateL')!=false)
								{
									$con.='$actionRateL="BlockIP";'.PHP_EOL;
								}
								else
								{
									$con .= $lineV.PHP_EOL;
								}
							}
							file_put_contents($fileName,$con);	
						}
						else
						{
							$content = explode('?>', $file);
							$file = $content[0];
							$file .= PHP_EOL;
							$file .= '$actionRateL="BlockIP";'.PHP_EOL;
							$file .='?>';
							file_put_contents($fileName,$file);
							$file = $data;
						}
					}
					elseif(sanitize_text_field($_POST['action'])=='ThrottleIP')
					{
						$file = $data;
						update_site_option('actionRateL',0);
						if(strpos($file, 'actionRateL')!=false)
						{
							$content = explode(PHP_EOL, $file);
							$con = '';
							foreach ($content as $line => $lineV) {
								if(strpos($lineV, 'actionRateL')!=false)
								{
									$con.='$actionRateL="ThrottleIP";'.PHP_EOL;
								}
								else
								{
									$con .= $lineV.PHP_EOL;
								}
							}
							file_put_contents($fileName,$con);	
						}
						else
						{
							$content = explode('?>', $file);
							$file = $content[0];
							$file .= PHP_EOL;
							$file .= '$actionRateL="ThrottleIP";'.PHP_EOL;
							$file .='?>';
							file_put_contents($fileName,$file);
						}	
					}

			}

		}	
			
		}

	}
	private function disableRL()
	{
		update_site_option('Rate_limiting',0);

		$dir_name =  dirname(__FILE__);
		$dir_name1 = explode('wp-content', $dir_name);
		$dir_name = $dir_name1[0];
		$filepath = str_replace('\\', '/', $dir_name1[0]);
		$fileName = $filepath.'/wp-includes/mo-waf-config.php';
		$file = file_get_contents($fileName);
			
		if(strpos($file, 'RateLimiting')!=false)
		{
			$file = str_replace('$RateLimiting=1;', '$RateLimiting=0;', $file);
			file_put_contents($fileName,$file);	
		}
		else
		{
			$content = explode('?>', $file);
			$file = $content[0];
			$file .= PHP_EOL;
			$file .= '$RateLimiting=0;'.PHP_EOL;
			$file .='?>';
			file_put_contents($fileName,$file);
		}

	}
	private function backupHtaccess()
	{
		if(isset($_POST['htaccessWAF']))
		{
			if(sanitize_text_field($_POST['htaccessWAF'])=='on')
			{
				$upload_dir 	=	wp_upload_dir();
				$dir_name 		=  $upload_dir['basedir'].DIRECTORY_SEPARATOR.'miniOrangeBackup';
				if(!file_exists($dir_name))
					mkdir($dir_name, 0777, true);
				
				$zipname  		= $dir_name.DIRECTORY_SEPARATOR.'WAFBackup.zip';
				$zip 	  		= new ZipArchive();

				if($zip->open($zipname, ZipArchive::CREATE | ZipArchive::OVERWRITE )==true)
				{
					$dir_path 		= get_home_path();
					$htaccessFile   = '';
					$userIniFile  	= '';
					$htaccessserver = sanitize_text_field($_POST['htaccessBackup']);
					$useriniserver  = sanitize_text_field($_POST['userIniBackup']);

					if($htaccessserver == 1)
					{
						$htaccessFile 	= $dir_path.DIRECTORY_SEPARATOR.'.htaccess';
						$zip->addFile($htaccessFile,'backup.htaccess');			
					}
					if($useriniserver == 1)
					{
						$userIniFile 	= $dir_path.DIRECTORY_SEPARATOR.'.user.ini';
						$zip->addFile($userIniFile,'backup.user.ini');	
					}
					$zip->close();	
				}
				
				$htaccessFile   = $dir_name.DIRECTORY_SEPARATOR.'.htaccess';
				$file 			= fopen($htaccessFile, 'w+');
				$content 		= 'deny from all';
				fwrite($file, $content);
				fclose($file);
			}
		}
	}
	private function limitAttack()
	{
		if(isset($_POST['limitAttack']))
		{
			$value = sanitize_text_field($_POST['limitAttack']);
			if($value>1)
			{
				update_site_option('limitAttack',$value);
				wp_send_json("limitSaved");
				exit;
			}
			else 
			{
				wp_send_json( "limitIsLT1");
				exit;
			}

		}
	}
	

	
	function wpns_captcha_settings(){
		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'wpns-captcha' ) ){
	   			wp_send_json ('ERROR');
	   			return;
	   		}
		$site_key = sanitize_text_field($_POST['site_key']);
		$secret_key = sanitize_text_field($_POST['secret_key']);
		$enable_captcha = sanitize_text_field($_POST['enable_captcha']);
		if($enable_captcha == 'true'){$enable_captcha = "on";}else if($enable_captcha == 'false') {$enable_captcha = "";}
		$login_form_captcha = sanitize_text_field($_POST['login_form']);
		if($login_form_captcha == 'true'){$login_form_captcha = "on";}else if($login_form_captcha == 'false') {$login_form_captcha = "";}
		$reg_form_captcha = sanitize_text_field($_POST['registeration_form']);
		if($reg_form_captcha == 'true'){$reg_form_captcha = "on";}else if($reg_form_captcha == 'false') {$reg_form_captcha = "";}

		if(($site_key == "" || $secret_key == "")){
			wp_send_json ('empty');
			return;
		} 

		update_site_option( 'mo_wpns_recaptcha_site_key'			 		, $site_key     );
		update_site_option( 'mo_wpns_recaptcha_secret_key'				, $secret_key   );
		update_site_option( 'mo_wpns_activate_recaptcha'			 		,  $enable_captcha );
		
		if($enable_captcha == "on"){
				update_site_option( 'mo_wpns_activate_recaptcha_for_login'	, $login_form_captcha );
				update_site_option( 'mo_wpns_activate_recaptcha_for_woocommerce_login', $login_form_captcha );
				update_site_option('mo_wpns_activate_recaptcha_for_registration', $reg_form_captcha   );
				update_site_option( 'mo_wpns_activate_recaptcha_for_woocommerce_registration',$reg_form_captcha   );
				wp_send_json ('true');
			}
			else if($enable_captcha == ""){
				update_site_option( 'mo_wpns_activate_recaptcha_for_login'	, '' );
				update_site_option( 'mo_wpns_activate_recaptcha_for_woocommerce_login', '' );
				update_site_option('mo_wpns_activate_recaptcha_for_registration', ''   );
				update_site_option( 'mo_wpns_activate_recaptcha_for_woocommerce_registration','' );
				wp_send_json ('false');
			}
		
	}	

	function wpns_strong_password_settings(){
		$nonce = sanitize_text_field($_POST['nonce']);
	   		if ( ! wp_verify_nonce( $nonce, 'wpns-strn-pass' ) ){
	   			wp_send_json ('ERROR');
	   			return;
	   		}
		$enable_strong_pass = sanitize_text_field($_POST['enable_strong_pass']);
		if($enable_strong_pass == 'true'){$enable_strong_pass = 1;}else if($enable_strong_pass == 'false') {$enable_strong_pass = 0;}
		$strong_pass_accounts = sanitize_text_field($_POST['accounts_strong_pass']);
		update_site_option('mo2f_enforce_strong_passswords_for_accounts',$strong_pass_accounts);  
		update_site_option('mo2f_enforce_strong_passswords' , $enable_strong_pass);
		if($enable_strong_pass){
			update_site_option('mo_wpns_enable_rename_login_url',"");
				wp_send_json ('true');
			}
			else{
				wp_send_json ('false');
			}
	}
	
}
new MOWAF_ajax;

?>
