<?php
    $dir        = $mowaf_dirname;
    $wafInclude = $dir.DIRECTORY_SEPARATOR.'handler'.DIRECTORY_SEPARATOR.'WAF'.DIRECTORY_SEPARATOR.'waf-include.php';
    $pluginU    = $dir.DIRECTORY_SEPARATOR.'helper'.DIRECTORY_SEPARATOR.'pluginUtility.php';
    $wafDB      = $dir.DIRECTORY_SEPARATOR.'handler'.DIRECTORY_SEPARATOR.'WAF'.DIRECTORY_SEPARATOR.'database'.DIRECTORY_SEPARATOR.'mo-waf-plugin-db.php';
    $errorPage  = $dir.DIRECTORY_SEPARATOR.'handler'.DIRECTORY_SEPARATOR.'mo-error.php';
    $blockPage  = $dir.DIRECTORY_SEPARATOR.'handler'.DIRECTORY_SEPARATOR.'mo-block.php';
    include_once($wafInclude);
    include_once($pluginU);
    include_once($wafDB);
    

    global $wpdb,$mowafhandle;
    $mowafhandle     = new MOWAF_Handler();
    $ipaddress      = mowaf_get_ipaddress();
    if($mowafhandle->is_ip_blocked($ipaddress))
    {
        if(!$mowafhandle->is_whitelisted($ipaddress))
        {
            header('HTTP/1.1 403 Forbidden');
            include_once($blockPage);
        }
    }
    $fileName = mowaf_setting_file();
    $SQL=0;
    $XSS=0;
    $RCE=0;
    $LFI=0;
    $RFI=0;
    $RateLimiting=0;
    $RequestsPMin=240;
    $actionRateL="ThrottleIP";

    if($fileName == 'permissionDenied')
    {
        $SQL = get_site_option("SQLInjection");
        $SQL = empty($SQL) ? 1 : $SQL;

        $XSS = get_site_option("XSSAttack");
        $XSS = empty($XSS) ? 1 : $XSS;
        
        $LFI = get_site_option("LFIAttack");
        $LFI = empty($LFI) ? 0 : $LFI;
        
        $RFI = get_site_option("RFIAttack");
        $RFI = empty($RFI) ? 0 : $RFI;
        
        $RCE = get_site_option("RCEAttack");
        $RCE = empty($RCE) ? 0 : $RCE;

        $RateLimiting = get_site_option("Rate_limiting");
        $RateLimiting = empty($RateLimiting) ? 0 : $RateLimiting;

        $RequestsPMin = get_site_option("Rate_request");
        $RequestsPMin = empty($RequestsPMin) ?  240 : $RequestsPMin;           
        
        $actionRateL = get_site_option("actionRateL");
        $actionRateL = empty($actionRateL) ? 0 : $actionRateL; 
        if($actionRateL== 0)
            $actionRateL="ThrottleIP";
        else
            $actionRateL="BlockIP";

        global $plugins_url;
        $plugins_url = get_site_option("mowaf_plugins_url");
    }
    else
        include_once($fileName);
    if(isset($RateLimiting) and $RateLimiting == 1)
    {
            mowaf_applyRateLimiting($RequestsPMin,$actionRateL,$ipaddress,$errorPage);

    }

    $attack = array();
    if($SQL==1)
    {
        array_push($attack,"SQL");
    }
    if($XSS==1)
    {
        array_push($attack,"XSS");
    }
    if($LFI==1)
    {
        array_push($attack,"LFI");
    }
    
    $attackC        = $attack;
    $ParanoiaLevel  = 1;
    $annomalyS      = 0;
    $SQLScore       = 0;
    $XSSScore       = 0;
    $limitAttack    = get_site_option('limitAttack');

   
    foreach ($attackC as $key1 => $value1)
    {
        for($lev=1;$lev<=$ParanoiaLevel;$lev++)
        {
            if(isset($regex[$value1][$lev]))
            {   $ooo = 0;
                for($i=0;$i<sizeof($regex[$value1][$lev]);$i++)
                {
                    foreach ($_REQUEST as $key => $value) {

                        if($regex[$value1][$lev][$i] != "")
                        {
                            if(is_string($value))
                            {
                                if(preg_match($regex[$value1][$lev][$i], $value))
                                {
                                   
                                    if($value1 == "SQL")
                                    {
                                        $SQLScore += $score[$value1][$lev][$i];
                                    }
                                    elseif ($value1 == "XSS")
                                    {
                                        $XSSScore += $score[$value1][$lev][$i];
                                    }
                                    else
                                    {
                                        $annomalyS += $score[$value1][$lev][$i];
                                    }

                                    if($annomalyS>=5 || $SQLScore>=10 || $XSSScore >=10)
                                    {
                                        $attackCount = mowaf_log_attack($ipaddress,$value1,$value);
                                        if($attackCount>$limitAttack)
                                        {
                                            if(!$mowafhandle->is_whitelisted($ipaddress))
                                            {
                                                if(!$mowafhandle->is_ip_blocked($ipaddress))
                                                    $mowafhandle->block_ip($ipaddress,'ALE',true); 
                                            }
                                        }

                                        header('HTTP/1.1 403 Forbidden');
                                        include_once($errorPage);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }




    function mowaf_applyRateLimiting($reqLimit,$action,$ipaddress,$errorPage)
    {
        global $wpdb,$mowafhandle;
        $rate = mowaf_CheckRate($ipaddress);
        if($rate>=$reqLimit)
        {
            $lastAttack     = mowaf_getRLEattack($ipaddress)+60;
            $current_time   = time();
            if($lastAttack < $current_time-60)
            {
                mowaf_log_attack($ipaddress,'RLE','RLE');
            }
            if($action != 'ThrottleIP')
            {   
                if(!$mowafhandle->is_whitelisted($ipaddress))
                {
                    $mowafhandle->block_ip($ipaddress,'RLE',true);
                }       
            }
            header('HTTP/1.1 403 Forbidden');
            include_once($errorPage);
        }
    }
 


?>
