<?php
	$dir        = dirname(__FILE__);   
    $wafInclude = $dir.DIRECTORY_SEPARATOR.'waf-include.php';
    $wafdb      = $dir.DIRECTORY_SEPARATOR.'database'.DIRECTORY_SEPARATOR.'mo-waf-db.php';
    $errorPage  = dirname($dir).DIRECTORY_SEPARATOR.'mo-error.php';
    $blockPage  = dirname($dir).DIRECTORY_SEPARATOR.'mo-block.php';

    include_once($wafInclude);
    include_once($wafdb);
    global $mowafdbcon,$mowafprefix;	
    $connection = mowaf_dbconnection();
    if($connection)
	{
        $wafLevel = mowaf_get_option_value('WAF');
        if($wafLevel=='HtaccessLevel')
        {
            $ipaddress = mowaf_get_ipaddress();
            if(mowaf_is_ip_blocked($ipaddress))
            {
                if(!mowaf_is_ip_whitelisted($ipaddress))
                {
                    header('HTTP/1.1 403 Forbidden');
                    include_once($blockPage);
                }
            }
            $fileName = mowaf_setting_file();
            $SQL=0;
            $XSS=0;
            $RCE=0;
            $LFI=0;
            $RFI=0;
            $RateLimiting=0;
            $RequestsPMin=240;
            $actionRateL="ThrottleIP";
            if($fileName == 'permissionDenied')
            {
                $SQL = mowaf_get_option_value("SQLInjection");
                $SQL = empty($SQL) ? 1 : $SQL;

                $XSS = mowaf_get_option_value("XSSAttack");
                $XSS = empty($XSS) ? 1 : $XSS;
                
                $LFI = mowaf_get_option_value("LFIAttack");
                $LFI = empty($LFI) ? 0 : $LFI;
                
                $RFI = mowaf_get_option_value("RFIAttack");
                $RFI = empty($RFI) ? 0 : $RFI;
                
                $RCE = mowaf_get_option_value("RCEAttack");
                $RCE = empty($RCE) ? 0 : $RCE;

                $RateLimiting = mowaf_get_option_value("Rate_limiting");
                $RateLimiting = empty($RateLimiting) ? 0 : $RateLimiting;

                $RequestsPMin = mowaf_get_option_value("Rate_request");
                $RequestsPMin = empty($RequestsPMin) ?  240 : $RequestsPMin;           
                
                $actionRateL = mowaf_get_option_value("actionRateL");
                $actionRateL = empty($actionRateL) ? 0 : $actionRateL; 
                if($actionRateL== 0)
                    $actionRateL="ThrottleIP";
                else
                    $actionRateL="BlockIP";
                global $plugins_url;
                $plugins_url = mowaf_get_option_value("mowaf_plugins_url");
            
            }
            else
                include_once($fileName);

            if(isset($RateLimiting) && $RateLimiting == 1)
            {
                    if(isset($RequestsPMin) && isset($actionRateL))
                        mowaf_applyRateLimiting($RequestsPMin,$actionRateL,$ipaddress,$errorPage);

            }

            $attack = array();
            if(isset($SQL) && $SQL==1)
            {
                array_push($attack,"SQL");
            }
            if(isset($XSS) && $XSS==1)
            {
                array_push($attack,"XSS");
            }
            if(isset($LFI) && $LFI==1)
            {
                array_push($attack,"LFI");
            }
			
            $attackC        = $attack;
            $ParanoiaLevel  = 1;
            $annomalyS      = 0;
            $SQLScore       = 0;
            $XSSScore       = 0;
            $limitAttack    = mowaf_get_option_value("limitAttack");

            foreach ($attackC as $key1 => $value1)
            {
                for($lev=1;$lev<=$ParanoiaLevel;$lev++)
                {
                    if(isset($regex[$value1][$lev]))
                    {	$ooo = 0;
                        for($i=0;$i<sizeof($regex[$value1][$lev]);$i++)
                        {
                            foreach ($_REQUEST as $key => $value) {

                                if($regex[$value1][$lev][$i] != "")
                                {
                                    if(is_string($value))
                                    {
                                        if(preg_match($regex[$value1][$lev][$i], $value))
                                        {
                                           
                                            if($value1 == "SQL")
                                            {
                                                $SQLScore += $score[$value1][$lev][$i];
                                            }
                                            elseif ($value1 == "XSS")
                                            {
                                                $XSSScore += $score[$value1][$lev][$i];
                                            }
                                            else
                                            {
                                                $annomalyS += $score[$value1][$lev][$i];
                                            }

                                            if($annomalyS>=5 || $SQLScore>=10 || $XSSScore >=10)
                                            {
                                                $attackCount = mowaf_log_attack($ipaddress,$value1,$value);
                                                if($attackCount>$limitAttack)
                                                {
                                                    if(!mowaf_is_ip_whitelisted($ipaddress))
                                                    {
                                                        mowaf_block_ip($ipaddress,'ALE');
                                                    }
                                                }

                                                header('HTTP/1.1 403 Forbidden');
                                                include_once($errorPage);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    
    function mowaf_applyRateLimiting($reqLimit,$action,$ipaddress,$errorPage)
    {
        global $mowafdbcon, $mowafprefix;
        $rate = mowaf_CheckRate($ipaddress);
        if($rate>$reqLimit)
        {
            $lastAttack     = mowaf_getRLEattack($ipaddress)+60;
            $current_time   = time();
            if($current_time > $lastAttack)
            {
                mowaf_log_attack($ipaddress,'RLE','RLE');
            }
            if($action != 'ThrottleIP')
            {
               if(!mowaf_is_ip_whitelisted($ipaddress))
                {
                    mowaf_block_ip($ipaddress,'RLE');
                }
            }
            header('HTTP/1.1 403 Forbidden');
            include_once($errorPage);        
        }
    }
    	
	$mowafdbcon->close();
?>
