<?php

class MOWAF_cURL
{

	public static function create_customer($email, $company, $password, $phone = '', $first_name = '', $last_name = '')
	{
		$url = MOWAF_Constants::HOST_NAME . '/moas/rest/customer/add';
		$fields = array (
			'companyName' 	 => $company,
			'areaOfInterest' => 'Web Application Firewall',
			'firstname' 	 => $first_name,
			'lastname' 		 => $last_name,
			'email' 		 => $email,
			'phone' 		 => $phone,
			'password' 		 => $password
		);
		$json = json_encode($fields);
		 $mowaf_api = new MOWAF_Api(); 
        $response = $mowaf_api->make_curl_call($url, $json);
		return $response;
	}
	
	public static function get_customer_key($email, $password) 
	{
		$url 	= MOWAF_Constants::HOST_NAME. "/moas/rest/customer/key";
		$fields = array (
					'email' 	=> $email,
					'password'  => $password
				);
		$json = json_encode($fields);
		 $mowaf_api = new MOWAF_Api(); 
        $response = $mowaf_api->make_curl_call($url, $json);
		return $response;
	}
	
	function submit_contact_us( $q_email, $q_phone, $query )
	{
		$current_user = wp_get_current_user();
		$url    = MOWAF_Constants::HOST_NAME . "/moas/rest/customer/contact-us";
		global $mowafutility;
		$query = '[WordPress Firewall ]: ' . $query;
		
		$fields = array(
					'firstName'	=> $current_user->user_firstname,
					'lastName'	=> $current_user->user_lastname,
					'company' 	=> $_SERVER['SERVER_NAME'],
					'email' 	=> $q_email,
					'ccEmail'   => '2fasupport@xecurify.com',
					'phone'		=> $q_phone,
					'query'		=> $query
				);
		$field_string = json_encode( $fields );
		 $mowaf_api = new MOWAF_Api(); 
        $response = $mowaf_api->make_curl_call($url, $field_string);
		$response;
		return $response;
	}

	function validate_recaptcha($ip,$response)
	{
		$url 		 = MOWAF_Constants::RECAPTCHA_VERIFY;
		$json		 = "";
		$fields 	 = array(
							'response' => $response,
							'secret'   => get_site_option('mo_wpns_recaptcha_secret_key'),
							'remoteip' => $ip
						);
		foreach($fields as $key=>$value) { $json .= $key.'='.$value.'&'; }
		rtrim($json, '&');
		 $mowaf_api = new MOWAF_Api(); 
        $response = $mowaf_api->make_curl_call($url, $json, null);
		return $response;
	}

	
	function check_customer($email)
	{
		$url 	= MOWAF_Constants::HOST_NAME . "/moas/rest/customer/check-if-exists";
		$fields = array(
					'email' 	=> $email,
				);
		$json     = json_encode($fields);
		 $mowaf_api = new MOWAF_Api(); 
        $response = $mowaf_api->make_curl_call($url, $json);
		return $response;
	}
	
	function mo_wpns_forgot_password()
	{
	
		$url 		 = MOWAF_Constants::HOST_NAME . '/moas/rest/customer/password-reset';
		$email       = get_site_option('mo2f_email');
		$customerKey = get_site_option('mo2f_customerKey');
		$apiKey 	 = get_site_option('mo2f_api_key');
	
		$fields 	 = array(
						'email' => $email
					 );
	
		$json 		 = json_encode($fields);
		$authHeader  = $this->createAuthHeader($customerKey,$apiKey);
        $mowaf_api = new MOWAF_Api(); 
        $response = $mowaf_api->make_curl_call($url, $json,$authHeader);
		return $response;
	}

	function send_email_alert( $email, $phone, $message ) {
        $url = MOWAF_Constants::HOST_NAME . '/moas/api/notify/send';
        $mowaf_api = new MOWAF_Api();
        $customerKey = MOWAF_Constants::DEFAULT_CUSTOMER_KEY;
        $apiKey 	 = MOWAF_Constants::DEFAULT_API_KEY;
		$currentTimeInMillis = $mowaf_api->get_timestamp();
		$stringToHash        = $customerKey . $currentTimeInMillis . $apiKey;
		$hashValue           = hash( "sha512", $stringToHash );
		$fromEmail           = $email;
		$subject             = "Web Application Firewall Feedback - " . $email;

		global $user;
		$user                       = wp_get_current_user();

		$query = '[Web Application Firewall: V - '.MOWAF_VERSION.']: ' . $message;

		$content = '<div >First Name :' . $user->user_firstname . '<br><br>Last  Name :' . $user->user_lastname . '   <br><br>Company :<a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>Phone Number :' . $phone . '<br><br>Email :<a href="mailto:' . $fromEmail . '" target="_blank">' . $fromEmail . '</a><br><br>Query :' . $query . '</div>';

		$fields       = array(
			'customerKey' => $customerKey,
			'sendEmail'   => true,
			'email'       => array(
				'customerKey' => $customerKey,
				'fromEmail'   => $fromEmail,
				'fromName'    => 'Xecurify',
				'toEmail'     => '2fasupport@xecurify.com',
				'toName'      => '2fasupport@xecurify.com',
				'subject'     => $subject,
				'content'     => $content
			),
		);
		$field_string = json_encode( $fields );

        $headers = $mowaf_api->get_http_header_array();

        $response = $mowaf_api->make_curl_call( $url, $field_string, $headers );
        return $response;


	}

	private static function createAuthHeader($customerKey, $apiKey) {
		$currentTimestampInMillis = round(microtime(true) * 1000);
		$currentTimestampInMillis = number_format($currentTimestampInMillis, 0, '', '');

		$stringToHash = $customerKey . $currentTimestampInMillis . $apiKey;
		$authHeader = hash("sha512", $stringToHash);

		$header = array (
			"Content-Type: application/json",
			"Customer-Key: $customerKey",
			"Timestamp: $currentTimestampInMillis",
			"Authorization: $authHeader"
		);
		return $header;
	}

}