<?php
	
	class MOWAF_Messages
	{
		const INVALID_IP						= "The IP address you entered is not valid or the IP Range is not valid.";
		const IP_PERMANENTLY_BLOCKED			= "IP Address is blocked permanently.";
		const IP_IN_WHITELISTED					= "IP Address is Whitelisted. Please remove it from the whitelisted list.";
		const IP_WHITELISTED					= "IP has been whitelisted successfully";
		const RECAPTCHA_ENABLED					= "Google reCAPTCHA configuration is enabled.";
		const RECAPTCHA_DISABLED				= "Google reCAPTCHA configuration is disabled.";		

		const NOTIFY_ON_IP_BLOCKED				= "Email notification is enabled for Admin.";
		const DONOT_NOTIFY_ON_IP_BLOCKED		= "Email notification is disabled for Admin.";
		const NOTIFY_ON_UNUSUAL_ACTIVITY		= "Email notification is enabled for user for unusual activities.";
		const DONOT_NOTIFY_ON_UNUSUAL_ACTIVITY  = "Email notification is disabled for user for unusual activities.";

		const DOMAIN_BLOCKING_ENABLED			= "Blocking fake user registrations is Enabled.";
		const DOMAIN_BLOCKING_DISABLED			= "Blocking fake user registration is disabled";
		const ENABLE_ADVANCED_USER_VERIFY		= "Advanced user verification is Enabled.";
		const DISABLE_ADVANCED_USER_VERIFY		= "Advanced user verification is Disable.";
		const ENABLE_SOCIAL_LOGIN				= "Social Login Integration is Enabled.";
		const DISABLE_SOCIAL_LOGIN				= "Social Login Integration is Disabled.";

		const HTACCESS_ENABLED					= "htaccess security has been enabled";
		const HTACCESS_DISABLED					= "htaccess security has been disabled";
		const USER_AGENT_BLOCK_ENABLED			= "Selected browsers have been blocked.";
		const USER_AGENT_BLOCK_DISABLED			= "Browser blocking is disabled.";
		const INVALID_IP_FORMAT 				= "Please enter Valid IP Range.";

		const CONTENT_PROTECTION_ENABLED		= "Your configuration for Content Protection has been saved.";
		const CONTENT_SPAM_BLOCKING				= "Protection for Comment SPAM has been enabled.";
		const CONTENT_RECAPTCHA					= "reCAPTCHA has been enabled for Comments.";
		const CONTENT_SPAM_BLOCKING_DISABLED	= "Protection for Comment SPAM has been disabled.";
		const CONTENT_RECAPTCHA_DISABLED		= "reCAPTCHA has been disabled for Comments.";


		const SUPPORT_FORM_VALUES				= "Please submit your query along with email.";
		const SUPPORT_FORM_SENT					= "Thanks for getting in touch! We shall get back to you shortly.";
		const SUPPORT_FORM_ERROR				= "Your query could not be submitted. Please try again.";

        const DEMO_FORM_ERROR					= "Please fill out all the fields.";

		const UNKNOWN_ERROR						= "Error processing your request. Please try again.";
		const CONFIG_SAVED						= "Configuration saved successfully.";
		const REQUIRED_FIELDS					= "Please enter all the required fields";
		const RESET_PASS						= "You password has been reset successfully and sent to your registered email. Please check your mailbox.";
		const TEMPLATE_SAVED					= "Email template saved.";
		const FEEDBACK							= "<div class='custom-notice notice notice-warning feedback-notice'><p><p class='notice-message'>Looking for a feature? Help us make the plugin better. Send us your feedback using the Support Form below.</p><button class='feedback notice-button'><i>Dismiss</i></button></p></div>";
		const WHITELIST_SELF					= "<div class='custom-notice notice notice-warning whitelistself-notice'><p><p class='notice-message'>It looks like you have not whitelisted your IP. Whitelist your IP as you can get blocked from your site.</p><button class='whitelist_self notice-button'><i>WhiteList</i></button></p></div>";

		const PASS_LENGTH						= "Choose a password with minimum length 6.";
		const REG_SUCCESS						= 'Your account has been retrieved successfully.';
		const ACCOUNT_EXISTS					= 'You already have an account with miniOrange. Please enter a valid password.';
		const PASS_MISMATCH						= 'Password and Confirm Password do not match.';
        const INVALID_EMAIL  					= 'Please enter valid Email ID';
        const EMAIL_SAVED 						= 'Email ID saved successfully';
        const ALL_ENABLED						= "All Website security features are available.";
        const ALL_DISABLED						= 'All Website security features are disabled.';
        const LOGIN_ENABLE						= 'Login security and spam protection features are available. Configure it in the Login and Spam tab.';
        const LOGIN_DISABLE						= 'Login security and spam protection features are disabled.';
        const NONCE_ERROR						= 'ERROR';
        const ADV_BLOCK_ENABLE					= 'Advanced blocking features are available. Configure it in the Advanced blocking tab.';
        const ADV_BLOCK_DISABLE					= 'Advanced blocking features are disabled.';
        const REPORT_ENABLE						= 'Login and error reports are available in the Reports tab.';
        const REPORT_DISABLE					= 'Login and error reports are disabled.';
        const NOTIF_ENABLE						= 'Notification options are available. Configure it in the Notification tab.';
        const NOTIF_DISABLE						= 'Notifications are disabled.';
  
  
		public static function showMessage($message , $data=array())
		{
			$message = constant( "self::".$message );
		    foreach($data as $key => $value)
		    {
		        $message = str_replace("{{" . $key . "}}", $value , $message);
		    }
		    return $message;
		}

	}

?>
