<?php
	
	class MOWAF_FeaturePluginInterface
	{
		function __construct()
		{
			if ( ! function_exists( 'get_plugins' ) )
				require_once ABSPATH . 'wp-admin'.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'plugin.php';	
		}
	}


	class MOWAF_OTPPlugin extends MOWAF_FeaturePluginInterface
	{
		function getstatus()
		{
		    $all_plugins = get_plugins();
			$status = 'NOT_INSTALLED';
			if(isset($all_plugins[MOWAF_Constants::OTP_VERIFICATION_SETTINGS]))
				$status = is_plugin_active(MOWAF_Constants::OTP_VERIFICATION_SETTINGS) ? 'ACTIVE' : 'INSTALLED';
			return $status;
		}

		function updatePluginConfiguration()
		{
			if(!get_site_option('mo_wpns_enable_advanced_user_verification'))
				return;

			if(!get_site_option( 'mo_customer_validation_admin_email') || !get_site_option( 'mo_customer_validation_admin_customer_key') || !get_site_option( 'mo_customer_validation_admin_api_key') || !get_site_option( 'mo_customer_validation_customer_token'))
			{
				update_site_option( 'mo_customer_validation_wp_default_enable'	,1);
				update_site_option( 'mo_customer_validation_admin_email'			,get_site_option( 'mo2f_email'));
				update_site_option( 'mo_customer_validation_admin_phone'			,get_site_option( 'mo_wpns_admin_phone'));
				update_site_option( 'mo_customer_validation_admin_customer_key'	,get_site_option( 'mo2f_customerKey') );
				update_site_option( 'mo_customer_validation_admin_api_key'		,get_site_option( 'mo2f_api_key') );
				update_site_option( 'mo_customer_validation_customer_token'		,get_site_option( 'mo2f_customer_token') );
				update_site_option( 'mo_customer_validation_admin_password'		,'');
				update_site_option( 'mo_customer_validation_message'				,'Registration complete!');
				update_site_option( 'mo_customer_validation_registration_status'	,'MO_CUSTOMER_VALIDATION_REGISTRATION_COMPLETE');
				update_site_option( 'mo_customer_email_transactions_remaining'	,10);
				update_site_option( 'mo_customer_phone_transactions_remaining'	,10);
				update_site_option( 'mo_otp_plugin_version'						,1.8);	
			}
		}
		
	}


	class MOWAF_SocialPlugin extends MOWAF_FeaturePluginInterface
	{
		function getstatus()
		{
		    $all_plugins = get_plugins();
			$status = 'NOT_INSTALLED';
			if(isset($all_plugins[MOWAF_Constants::SOCIAL_LOGIN_SETTINGS]))
				$status = is_plugin_active(MOWAF_Constants::SOCIAL_LOGIN_SETTINGS) ? 'ACTIVE' : 'INSTALLED';
			return $status;
		}
	}