<?php
/**
 * Plugin Name: Web Application Firewall
 * Description: Simple & Easy firewall setup. This plugin provides complete end to end website security.  
 * Version: 1.0.0
 * Author: miniOrange
 * Author URI: https://miniorange.com
 * License: GPL2
 */
    define( 'MOWAF_HOST_NAME', 'https://login.xecurify.com' );
	define( 'MOWAF_VERSION', '1.0.0' );
	class MOWAF{

		function __construct()
		{
			register_deactivation_hook(__FILE__		 , array( $this, 'mowaf_deactivate'		      )		);
			register_activation_hook  (__FILE__		 , array( $this, 'mowaf_activate'			  )		);
			add_action( 'admin_menu'				 , array( $this, 'mowaf_widget_menu'		  )		);
			add_action( 'admin_enqueue_scripts'		 , array( $this, 'mowaf_settings_style'	      )		);
			add_action( 'admin_enqueue_scripts'		 , array( $this, 'mowaf_settings_script'	  )	    );
			add_action( 'mowaf_show_message'		 , array( $this, 'mowaf_show_message' 	      ),1 ,2);
            add_action( 'admin_footer'				 , array( $this, 'mowaf_feedback_request' 	  )     );
			if(get_site_option('mo2f_disable_file_editing')) 
			if(!defined('DISALLOW_FILE_EDIT'))
			define('DISALLOW_FILE_EDIT', true);
			$this->mowaf_includes();
		}
		
        function mowaf_feedback_request() {
            if ( 'plugins.php' != basename( $_SERVER['PHP_SELF'] ) ) {
                return;
            }
            global $mowaf_dirname;

             $email = get_site_option("mo2f_email");
            if(empty($email)){
                $user = wp_get_current_user();
                $email = $user->user_email;
            }
            $imagepath=plugins_url('/includes/images/', __FILE__ );

            wp_enqueue_style( 'wp-pointer' );
            wp_enqueue_script( 'wp-pointer' );
            wp_enqueue_script( 'utils' );
            wp_enqueue_style( 'mo_wpns_admin_plugins_page_style', plugins_url(DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR.'style_settings.css?ver=1.0.0', __FILE__ ) );
            include $mowaf_dirname . 'views'.DIRECTORY_SEPARATOR.'feedback_form.php';;

        }
	
		function mowaf_widget_menu()
		{
				$menu_slug =  'mowaf_dashboard';

			add_menu_page (	'miniOrange Firewall' , 'Firewall' , 'administrator', $menu_slug , array( $this, 'mowaf'), plugin_dir_url(__FILE__) . 'includes'.DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.'miniorange_icon.png' );

			add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Dashboard'		    ,'administrator','mowaf_dashboard'			, array( $this, 'mowaf'),1);
			add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Firewall'		   		,'administrator','mowaf_waf'				, array( $this, 'mowaf'),2);
			add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Login and Spam'		,'administrator','mowaf_login_and_spam'	, array( $this, 'mowaf'),3);
            add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Advanced Blocking'	,'administrator','mowaf_advancedblocking'	, array( $this, 'mowaf'),4);
            add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Notifications'		,'administrator','mowaf_notifications'		, array( $this, 'mowaf'),5);
            add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Reports'				,'administrator','mowaf_reports'			, array( $this, 'mowaf'),6);
            add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Troubleshooting'		,'administrator','mowaf_troubleshooting'	, array( $this, 'mowaf'),7);
            add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Account'				,'administrator','mowaf_account'			, array( $this, 'mowaf'),8);
            add_submenu_page( $menu_slug	,'miniOrange Firewall'	,'Request for Demo'				,'administrator','mowaf_request_demo'			, array( $this, 'mowaf'),10);       
    }


		function mowaf()
		{
			global $mowafDbQueries;
			$mowafDbQueries->mo_plugin_activate();
			
			add_site_option( 'mo2f_enable_brute_force' , false);
			add_site_option( 'mo2f_show_remaining_attempts' , false);
			add_site_option( 'mo_wpns_enable_ip_blocked_email_to_admin', false);
			add_site_option('SQLInjection', 1);
			add_site_option('WAFEnabled' ,0);
			add_site_option('XSSAttack' ,1);
			add_site_option('RFIAttack' ,0);
			add_site_option('LFIAttack' ,0);
			add_site_option('RCEAttack' ,0);
			add_site_option('actionRateL',0);
			add_site_option('Rate_limiting',0);
			add_site_option('Rate_request',240);
			add_site_option('limitAttack',10);
			add_site_option( 'mo_wpns_check_vulnerable_code', 1);
			add_site_option( 'mo_wpns_check_sql_injection', 1);
			include 'controllers'.DIRECTORY_SEPARATOR.'main_controller.php';
		}

		function mowaf_activate()
		{
			global $mowafDbQueries;
			$mowafDbQueries->mo_plugin_activate();			
			$mowafDbQueries->insert_images();
			add_site_option( 'mo2f_activate_plugin', 1 );
			add_site_option( 'mo2f_login_option', 1 );
			add_site_option( 'mo2f_number_of_transactions', 1 );
			add_site_option( 'mo2f_set_transactions', 0 );
			add_site_option( 'mo2f_enable_xmlrpc', 0 );
			add_site_option( 'mo2fa_administrator',1 );
			add_site_option( 'mo2f_custom_plugin_name','miniOrange Firewall' );
			add_site_option( 'mo2f_show_sms_transaction_message', 0 );
			add_site_option( 'mo2f_enforce_strong_passswords_for_accounts' ,'all');
			add_site_option( 'mowaf_tab_count', 0);
			add_site_option( 'mowaf_home_path', get_home_path());
			add_site_option( 'mowaf_plugin_path', plugin_dir_path(__FILE__) );
		}

		function mowaf_deactivate() 
		{
			global $mowafutility;
			if( !$mowafutility->check_empty_or_null( get_site_option('mo_wpns_registration_status') ) ) {
				delete_site_option('mo2f_email');
			}
			update_site_option('mo2f_activate_plugin', 1);
			delete_site_option('mo2f_customerKey');
			delete_site_option('mo2f_api_key');
			delete_site_option('mo2f_customer_token');
			delete_site_option('mo_wpns_registration_status');
		}

		function mowaf_settings_style($hook)
		{
			if(strpos($hook, 'page_mowaf')){
				wp_enqueue_style( 'mowaf_admin_settings_style'			, plugins_url('includes'.DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR.'style_settings.css', __FILE__));
				wp_enqueue_style( 'mowaf_admin_settings_datatable_style'	, plugins_url('includes'.DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR.'jquery.dataTables.min.css', __FILE__));
				wp_enqueue_style( 'mowaf_button_settings_style'			, plugins_url('includes'.DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR.'button_styles.css',__FILE__));
			}

		}

		function mowaf_settings_script($hook)
		{
			wp_enqueue_script( 'mowaf_admin_settings_script'			, plugins_url('includes'.DIRECTORY_SEPARATOR.'js'.DIRECTORY_SEPARATOR.'settings_page.js', __FILE__ ), array('jquery'));
			if(strpos($hook, 'page_mowaf')){
				wp_enqueue_script( 'mowaf_admin_datatable_script'			, plugins_url('includes'.DIRECTORY_SEPARATOR.'js'.DIRECTORY_SEPARATOR.'jquery.dataTables.min.js', __FILE__ ), array('jquery'));
			}
		}
		function mowaf_show_message($content,$type) 
		{
		     if($type=="CUSTOM_MESSAGE")
			{
				echo "<div class='overlay_not_JQ_success' id='pop_up_success'><p class='popup_text_not_JQ'>".esc_html($content)."</p> </div>";
				?>
				<script type="text/javascript">
				 setTimeout(function () {
					var element = document.getElementById("pop_up_success");
					   element.classList.toggle("overlay_not_JQ_success");
					   element.innerHTML = "";
						}, 4000);
						
				</script>
				<?php
			}
			 if($type=="NOTICE")
			{
				echo "<div class='overlay_not_JQ_error' id='pop_up_error'><p class='popup_text_not_JQ'>".esc_html($content)."</p> </div>";
				?>
				<script type="text/javascript">
				 setTimeout(function () {
					var element = document.getElementById("pop_up_error");
					   element.classList.toggle("overlay_not_JQ_error");
					   element.innerHTML = "";
						}, 4000);
						
				</script>
				<?php
			}
			 if($type=="ERROR")
			 {
				echo "<div class='overlay_not_JQ_error' id='pop_up_error'><p class='popup_text_not_JQ'>".esc_html($content)."</p> </div>";
				?>
				<script type="text/javascript">
				 setTimeout(function () {
					var element = document.getElementById("pop_up_error");
					   element.classList.toggle("overlay_not_JQ_error");
					   element.innerHTML = "";
						}, 4000);
						
				</script>
				<?php
			 }
			 if($type=="SUCCESS")
			 	{
					echo "<div class='overlay_not_JQ_success' id='pop_up_success'><p class='popup_text_not_JQ'>".esc_html($content)."</p> </div>";
					?>
					<script type="text/javascript">
					 setTimeout(function () {
						var element = document.getElementById("pop_up_success");
						   element.classList.toggle("overlay_not_JQ_success");
						   element.innerHTML = "";
							}, 4000);
							
					</script>
					<?php
				}
		}

		function mowaf_includes()
		{
			require('helper'.DIRECTORY_SEPARATOR.'pluginUtility.php');
			require('database'.DIRECTORY_SEPARATOR.'database_functions.php');
			require('helper'.DIRECTORY_SEPARATOR.'utility.php');
			require('handler'.DIRECTORY_SEPARATOR.'ajax.php');
			require('handler'.DIRECTORY_SEPARATOR.'feedback_form.php');
			require('handler'.DIRECTORY_SEPARATOR.'recaptcha.php');
			require('handler'.DIRECTORY_SEPARATOR.'login.php');
			require('handler'.DIRECTORY_SEPARATOR.'registration.php');
			require('handler'.DIRECTORY_SEPARATOR.'logger.php');
			require('handler'.DIRECTORY_SEPARATOR.'spam.php');
			require('helper'.DIRECTORY_SEPARATOR.'curl.php');
			require('helper'.DIRECTORY_SEPARATOR.'plugins.php');
			require('helper'.DIRECTORY_SEPARATOR.'constants.php');
			require('helper'.DIRECTORY_SEPARATOR.'messages.php');
			require('views'.DIRECTORY_SEPARATOR.'common-elements.php');
			require('api'.DIRECTORY_SEPARATOR.'mo2f_api.php');
			 
			require('controllers'.DIRECTORY_SEPARATOR.'wpns-loginsecurity-ajax.php');
			require('controllers'.DIRECTORY_SEPARATOR.'dashboard_ajax.php');
		}

	}

	new MOWAF;
?>